# Soccer Stadium

Նագյերդոն Դեբրեսեն քաղաքում տեղակայված քառակուսաձև անտառ է, որը կարելի է ներկայացնել $N \times N$  չափի վանդակավոր ցանցի միջոցով։
Վանդակավոր ցանցի սյուները համարակալված են $0$-ից $N - 1$ թվերով արևմուտքից արևելք, իսկ տողերը համարակալված են $0$-ից $N - 1$ թվերով հյուսիսից հարավ։ Վանդակավոր ցանցի $r$-րդ տողի $c$-րդ սյունում գտնվող վանդակը նշանակենք $(r, c)$։

Անտառում յուրաքանչյուր վանդակ կամ  **դատարկ է**, կամ այնտեղ **ծառ** կա։
Անտառում առնվազն մեկ դատարկ վանդակ կա։

Քաղաքում հայտնի DVSC սպորտային ակումբը պլանավորում է անտառում կառուցել նոր ֆուտբոլի ստադիոն։
 $s$ չափի ստադիոնը (որտեղ $s \ge 1$) դա $s$ *տարբեր դատարկ* վանդակների բազմություն է $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$։
Դա ֆորմալ նշանակում է․
- $0$-ից $s - 1$ յուրաքանչյուր $i$-ի համար $(r_i, c_i)$ վանդակը դատարկ է,
- յուրաքանչյուր $i, j$-ի համար, այնպիսիք, որ $0 \le i \lt j \lt s$, հետևյալ պայմաններից առնվազն մեկը տեղի ունի․ $r_i \neq r_j$ և $c_i \neq c_j$։

Ֆուտբոլ խաղում են գնադակը տեղափոխելով ստադիոնի դատարկ վանդակներով։ Հետևյալ երկու գործողություններից յուրաքանչյուրը կոչվում է **ուղիղ հարված**․
* Տեղափոխել գնդակը $(r,a)$ վանդակից $(r,b)$ ($0 \le r,a,b \lt N, a \ne b$) վանդակ, որտեղ ստադիոնը պարունակում է $r$ տողի $(r,a)$-ի և $(r,b)$-ի միջև եղած *բոլոր* վանդակները ներառյալ։ Դա նշանակում է՝
 - եթե $a \lt b$, ապա բոլոր $(r,k)$ վանդակները, որտեղ $k$-ն բավարարում է $a \le k \le b$ պայմանին, ստադիոնի մեջ են մտնում,
 - եթե $a \gt b$, ապա բոլոր $(r,k)$ վանդակները, որտեղ $k$-ն բավարարում է $b \le k \le a$ պայմանին, ստադիոնի մեջ են մտնում։
* Տեղափոխել գնդակը $(a,c)$ վանդակից $(b,c)$  ($0 \le c,a,b \lt N, a \ne b$) վանդակ, որտեղ ստադիոնը պարունակում է $c$ սյան $(a,c)$,ի և $(b,c)$-ի միջև եղած *բոլոր* վանդակները։ Դա նշանակում է՝
 - եթե $a \lt b$, ապա բոլոր $(k,c)$ վանդակները, որտեղ $k$,ն բավարարում է $a \le k \le b$ պայմանին, ստադիոնի մեջ են մտնում,
 - եթե $a \gt b$, ապա բոլոր $(k,c)$ վանդակները, որտեղ $k$-ն բավարարում է $b \le k \le a$ պայմանին, ստադիոնի մեջ են մտնում։

Ստադիոնը կոչվում է **կանոնավոր**, եթե հնարավոր է գնդակը ստադիոնի ցանկացած վանդակից տեղափոխել ցանկացած այլ վանդակ առավելագյունը  $2$ ուղիղ հարվածի միջոցով։ Նկատենք, որ $1$ չափի ստադիոնը կանոնավոր է։

Օրինակ, դիտակենք $N = 5$ չափի անտառ, որի $(1,0)$ և $(4,2)$ վանդակներում ծառ կա, իսկ մնացած բոլոր վանդակները դատարկ են։ Ստորև բերված նկարում պատկերված են երեք ստադիոններ։ Ծառեր պարունակող վանդակները սև գույնով են ներկված, իսկ ստադիոնին պատկանող վանդակները շտրիխավորված են։.
 
![Stadiums](soccer-regular.png "650")

Ձախ կողմի ստադիոնը կանոնավոր է։ Մեջտեղի ստադիոնը կանոնավոր չէ, որովհետև առնվազն $3$ ուղիղ հարված է պետք գնդակը $(4,1)$ վանդակից $(4,3)$ վանդակ տեղափոխելու համար։ Աջ կողմի ստադիոնը նույնպես կանոնավոր չէ, որովհետև հնարավոր չէ ուղիղ հարվածների միջոցով գնդակը  $(3,0)$ վանդակից տեղափոխել $(1,3)$ վանդակ։

Սպորտային ակումբը ցանկանում է կառուցել, որքան հնարավոր է մեծ կանոնավոր ստադիոն։ Ձեր խնդիրն է գտնել $s$-ի մեծագույն արժեքը, այնպիսին, որ անտառում գոյություն ունի $s$ չափի կանոնավոր ստադիոն։

## Իրականացման մանրամասներ

Դուք պետք է ծրագրավորեք հետևյալ ֆունկցիան․

```
int biggest_stadium(int N, int[][] F)
```

* $N$․ անտառի չափը։
* $F$․ անտառի վանդակները պարունակող $N$ երկարության զանգված, որի յուրաքանչյուր  տարրը $N$ երկարության զանգված է։ Յուրաքանչյուր $r$-ի և $c$-ի համար, այնպիսիք, որ $0 \le r \lt N$ և $0 \le c \lt N$, $F[r][c] = 0$ նշանակում է, որ $(r, c)$ վանդակը դատարկ է, իսկ $F[r][c] = 1$ նշանակում է, որ այդ վանդակում ծառ կա։
* Այս ֆունկցիան պետք է վերադարձնի անտառում հնարավոր մեծագույն կանոնավոր ստադիոնի չափը, որ կարելի է կառուցել։
* Այս ֆունկցիան կանչվում է յուրաքանչուր թեստի համար ճիշտ մեկ անգամ։

## Օրինակ

Դիտարկենք հետևյալ կանչը․

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

Հետևյալ նկարի ձախ մասում պատկերված է այս օրինակի անտառը, իսկ աջ մասում պատկերված է $20$ չափի կանոնավոր ստադիոն․

![Example](soccer-example.png "400")

Քանի որ $21$ և ավելի չափի կանոնավոր ստադիոն գոյություն չունի, ֆունկցիան պետք է վերադարձնի $20$։

## Սահմանափակումներ

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ (որտեղ $0 \le i \lt N$ և $0 \le j \lt N$)
* Անտառում կա առնվազն մեկ դատարկ վանդակ։ Այլ կերպ ասած, $F[i][j] = 0$ որևէ $0 \le i \lt N$ և $0 \le j \lt N$ համար։

## Ենթախնդիրներ

1. (6 միավոր) Կա ծառ պարունակող առավելագույնը մեկ վանդակ։
2. (8 միավոր) $N \le 3$
3. (22 միավոր) $N \le 7$ 
4. (18 միավոր) $N \le 30$ 
5. (16 միավոր) $N \le 500$
6. (30 միավոր) Լրացուցիչ սահմանափակումներ չկան։

Յուրաքանչյուր ենթախնդրում Դուք կարող եք ձեռք բերել մասնակի միավոր, եթե Ձեր ծրագիրը ճիշտ կարողանում է պարզել է, թե *բոլոր* դատարկ վանդակները ստադիոն են կազմում, թե ոչ։

Ավելի ճշգրիտ, յուրաքանչյուր թեստի համար, որտեղ բոլոր դատարկ վանդակները ստադիոն են կազում, Ձեր լուծումը
* ստանում է լրիվ միավոր, եթե վերադարձնում է ճիշտ պատասխանը (դատարկ վանդակների քանակը).
* ստանում է 0 միավոր հակառակ դեպքում։

Յուրաքանչուր թեստի համար, որտեղ բոլոր դատարկ վանդակները կանոնավոր ստադիոն *չեն* կազմում, Ձեր ծրագիրը
* ստանում է լրիվ միավոր, եթե վերադարձնում է ճիշտ պատասխան,
* ստանում է 0 միավոր, եթե վերադարձնում է դատարկ վանդակների քանակը,
* ստանում է միավորի 25%, ցանկացած այլ պատասխանի դեպքում։

Յուրաքանչյուր ենթախնդրի համար տրվում է այդ ենթախնդրի թեստերի համար տրված միավորներից մինիմումը։

## Գրեյդերի նմուշ

Գրեյդերի նմուշը մուտքային տվյալները կարդում է հետևյալ ձևաչափով․ 
 
* տող $1$․ $N$
* տող $2 + i$  ($0 \le i \lt N$)․  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
Գրեյդերի նմուշը տպում է Ձեր պատասխանը հետևյալ ձևաչափով․
* տող $1$․ `biggest_stadium` ֆունկցիայի վերադարձրած արժեքը։
