# Futbol Stadionu

Debrecen şəhərində kvadrat formasında olan Nagyerdő adlı meşə var. Bu meşəni $N \times N$  ölçülü qrid formasında göstərmək olar.
Qridin sətirləri şimaldan cənuba doğru $0$'dan $N-1$'ə,
sütunları isə qərbdən şərqə doğru $0$'dan $N-1$'ə nömrələnib.
$r$ sətrində $c$ sütununda olan xananı $(r, c)$ adlandıraq.

Meşədə hər bir xana ya **boşdur** ya da **ağac** var.
Meşədə ən az bir xana boşdur.

Şəhərin məşhur idman klubu DVSC təzə futbol stadionu qurmağı planlayır. $s$ ölçülü stadion *müxtəlif boş* olan $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$. xanalarıdır. Yəni:
 - $0$'dan $s-1$'ə olan hər bir $i$ üçün $(r_i, c_i)$ xanası boşdur,
 - $i \lt j \lt s$ şərtini ödəyən hər $i$ və $j$ üçün $r_i \neq r_j$ və ya $c_i \neq c_j$ şərti ödənir.

Futbol, stadionun xanalarında hərəkət edən topdan istifadə etməklə oynanılır. **Düz zərbə** aşağıdakılardan hər hansı biri ola bilər:
* Topu $(r,a)$ xanasından $(r,b)$ xanasına göndər ($0 \le r,a,b \lt N, a \ne b$), hansı ki bu iki xana arasında olan bütün xanalar stadionun xanasıdır. Daha dəqiq desək,
 - əgər $a \lt b$ şərti ödənsə o zaman $a \le k \le b$ şərtini ödəyən bütün $k$'lar üçün $(r,k)$ xanaları stadiona məxsus olmalıdır. 
 - əgər $a \gt b$ şərti ödənsə o zaman $b \le k \le a$ şərtini ödəyən bütün $k$'lar üçün $(r,k)$ xanaları stadiona məxsus olmalıdır. 
* Topu $(a, c)$ xanasından $(b, c)$ ($0 \le c,a,b \lt N, a \ne b$),) xanasına apar, hansı ki bu iki xana arasında olan bütün xanalar stadionun xanasıdır. Daha dəqiq desək,
 - əgər $a \lt b$ şərti ödənsə o zaman $a \le k \le b$ şərtini ödəyən bütün $k$'lar üçün $(k, c)$ xanaları stadiona məxsus olmalıdır. 
 - əgər $a \gt b$ şərti ödənsə o zaman $b \le k \le a$ şərtini ödəyən bütün $k$'lar üçün $(k, c)$ xanaları stadiona məxsus olmalıdır. 

Stadion o zaman **düzgün** olur ki, topu stadiona məxsus olan istənilən xanadan stadiona məxsus istənilən xanaya ən çox $2$ düz zərbə ilə aparmaq olsun. Qeyd edək ki $1$ ölçülü stadion düzgündür.

Məsələn, $N = 5$ ölçülü, $(1,0)$ və $(4,2)$ xanalarında ağac olan, yerdə qalan bütün xanaları boş olan meşəyə nəzər yetirin. 
Aşağıdakı şəkillərdə üç müxtəlif mümkün stadion quruluşu göstərilib. Qara xanalarda ağac var, ştrixlənmiş xanalar isə stadiona aiddir.


![Stadiums](soccer-regular.png "650")

Soldakı stadion düzgündür. Lakin ortadakı stadion düzgün deyil, çünki topu $(4, 1)$ xanasından $(4, 3)$ xanasına aparmaq üçün ən az $3$ vuruş lazımdır. Sağdakı stadion da düzgün deyil çünki $(3, 0)$ xanasından $(1, 3)$ xanasına topu aparmaq mümkün deyil.

İdman klubu mümkün ən böyük stadionu tikmək istəyir. Sizin tapşırığınız elə maksimum $s$ dəyərini tapmaqdır ki, meşədə $s$ ölçülü düzgün stadion qurmaq mümkün olsun.



## İmplementasiya detalları

Aşağıdakı proseduru implement etməlisiniz.

```
int biggest_stadium(int N, int[][] F)
```

* $N$: meşənin ölçüsü.
* $F$: meşəni təmsil edən, hər bir elementi $N$ uzunluqlu massiv olan $N$ uzunluqlu massiv. $0 \le r \lt N$ və $0 \le c \lt N$ şərtini ödəyən hər $r$ və $c$ üçün $F[r][c] = 0$ xananın boş olduğu,  $F[r][c] = 1$ isə orada ağac olduğu mənasına gəlir.
* Bu prosedur mümkün ən böyük stadionun ölçüsünü qaytarmalıdır.
* Bu prosedur hər test üçün tam olaraq bir dəfə çağırılır.

## Nümunə

Aşağıdakı nümunəyə nəzər yetirin:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

Bu nümunədə, aşağıdakı şəkildə meşə solda, $20$ ölçülü düzgün stadion isə sağda göstərilib.

![Example](soccer-example.png "400")

$21$ və ya daha böyük ölçülü düzgün stadion olmadığı üçün prosedur $20$ qaytarır.


## Məhdudiyyətlər

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ ($0 \le i \lt N$ və $0 \le j \lt N$ şərtini ödəyən hər $i$ və $j$ üçün)
* Meşədə ən az bir dənə boş xana var. Başqa bir sözlə bəzi $0 \le i \lt N$ və $0 \le j \lt N$ ədədləri üçün $F[i][j] = 0$

## Alt tapşırıqlar

1. (6 bal) Ən çox bir xanada ağac var.
2. (8 bal) $N \le 3$
3. (22 bal) $N \le 7$ 
4. (18 bal) $N \le 30$ 
5. (16 bal) $N \le 500$
6. (30 bal) Əlavə məhdudiyyət yoxdur

Hər alt tapşırıqda əgər proqramınız içində *bütün* boş xanalar olan set'in düzgün stadion olub olmadığını tapsa, həmin alt tapşırığın balının 25%'ni ala bilərsiniz. Daha dəqiq desək, bütün boş olan xanaları götürdükdə düzgün stadion alınan testlər üçün sizin cavabınız:
* əgər düz cavabı tapsa tam bal alır (hansı ki bütün boş xanalar olan set'in ölçüsüdür),
* əks halda 0 bal alır.

Bütün boş xanaları götürdükdə alınan stadion düzgün *olmayan* bütün testlər üçün sizin cavabınız:
* düzgün cavabı qaytarsa tam bal alır,
* bütün boş xanalar olan set'in ölçüsünü qaytarsa 0 bal alır,
* əks halda 25% bal alır

Hər alt tapşırığın balı onun içindəki testlər arasındakı minimum baldır.

## Nümunə Qreyder

Nümunə qreyder girişi aşağıdakı formada oxuyur: 
 
* sətir $1$: $N$
* sətir $2 + i$  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
Nümunə qreyder cavabı aşağıdakı formada çıxışa verir:
* sətir $1$: `biggest_stadium` prosedurunun qaytardığı cavab
