# Jalgpallistaadion

Nagyerdő on Debreceni linnas asuv ruudukujuline mets, mida võib vaadelda $N \times N$ ruudustikuna.
Ruudustiku read on nummerdatud põhjast lõunasse $0$ kuni $N - 1$ ja veerud läänest itta $0$ kuni $N - 1$.
Tähistame reas $r$ ja veerus $c$ olevat ruutu $(r, c)$.

Metsa iga ruut võib olla **tühi** või selles võib olla **puu**.
On teada, et metsas on vähemalt üks tühi ruut.

Linna kuulsaim spordiklubi DVSC tahab metsa staadioni rajada.
Staadion suurusega $s$ (kus $s \ge 1$) on $s$ *paarikaupa erinevast tühjast* ruudust $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$ koosnev hulk.
Formaalsemalt:
- Iga $0 \le i \le s - 1$ korral on ruut $(r_i, c_i)$ tühi.
- Iga $0 \le i \le s - 1$ ja $i \lt j \lt s$ korral kehtib kas $r_i \neq r_j$ või $c_i \neq c_j$ või mõlemad.

Jalgpall on mäng, mida mängides tuleb palli staadionil ühelt ruudult teisele liigutada.
**Otselöök** on üks järgmisest kahest tegevusest:
* Palli liigutamine ruudust $(r,a)$ ruutu $(r,b)$, kus $0 \le r,a,b \lt N$ ja $a \ne b$ ja *kõik* rea $r$ ruudud $(r,a)$ ja $(r,b)$ vahel kuuluvad staadionisse. Formaalsemalt:
 - Kui $a \lt b$, siis peab iga $a \le k \le b$ korral ruut $(r,k)$ kuuluma staadionisse.
 - Kui $a \gt b$, siis peab iga $b \le k \le a$ korral ruut $(r,k)$ kuuluma staadionisse.
* Palli liigutamine ruudust $(a,c)$ ruutu $(b,c)$, kus $0 \le c,a,b \lt N$ ja $a \ne b$ ja *kõik* veeru $c$ ruudud $(a,c)$ ja $(b,c)$ vahel kuuluvad staadionisse. Formaalsemalt:
 - Kui $a \lt b$, siis peab iga $a \le k \le b$ korral ruut $(k,c)$ kuuluma staadionisse.
 - Kui $a \gt b$, siis peab iga $b \le k \le a$ korral ruut $(k,c)$ kuuluma staadionisse.

Staadioni nimetatakse **korrapäraseks**, kui palli saab liigutada igalt staadioni ruudult igale teisele staadioni ruudule ülimalt $2$ otselöögiga.
Pane tähele, et iga staadion suurusega $1$ on korrapärane.

Vaatleme näiteks metsa küljepikkusega $N = 5$, kus ruutudes $(1,0)$ ja $(4,2)$ on puud ja kõik teised ruudud on tühjad.
Järgnev joonis kujutab kolme võimalikku staadionit. Puudega ruudud on mustad ja staadionisse kuuluvad ruudud viirutatud.

![Stadiums](soccer-regular.png "650")

Vasakpoolne staadion on korrapärane. Keskmine staadion ei ole korrapärane, sest palli liigutamiseks ruudust $(4,1)$ ruutu $(4,3)$ on vaja vähemalt $3$ otselööki. Parempoolne staadion ei ole ka korrapärane, sest palli ei ole võimalik otselöökidega liigutada ruudust $(3,0)$ ruutu $(1,3)$.

Spordiklubi tahab rajada võimalikult suure korrapärase staadioni.
Sinu ülesanne on leida maksimaalne $s$ väärtus, mille korral on võimalik metsa rajada korrapärane staadion suurusega $s$.

## Realisatsioon

Lahendusena tuleb realiseerida funktsioon

```
int biggest_stadium(int N, int[][] F)
```

* $N$: metsa küljepikkus.
* $F$: $N$ elemendiga massiiv, mille elemendid on omakorda $N$ elemendiga massiivid. Iga $0 \le r \lt N$ ja $0 \le c \lt N$ korral tähendab $F[r][c] = 0$, et ruut $(r, c)$ on tühi, ja $F[r][c] = 1$, et ruudus $(r, c)$ on puu.
* Funktsioon peab tagastama maksimaalse võimaliku korrapärasse staadioni suuruse.
* Seda funktsiooni käivitatakse igas testis täpselt üks kord.

## Näide

Vaatleme väljakutset

```
biggest_stadium(5, [[0, 0, 0, 0, 0],
                    [1, 0, 0, 0, 0],
                    [0, 0, 0, 0, 0],
                    [0, 0, 0, 0, 0],
                    [0, 0, 1, 0, 0]])
```

Alloleval joonisel on vasakul kujutatud sellele näitele vastav mets ja paremal korrapärane staadion suurusega $20$.

![Example](soccer-example.png "400")

Kuna sellesse metsa pole võimalik rajada staadioni, mille suurus oleks $21$ või rohkem, peab funktsioon tagastama $20$.

## Piirangud

* $1 \le N \le 2\,000$.
* $0 \le F[i][j] \le 1$ iga $0 \le i \lt N$ ja $0 \le j \lt N$ korral.
* Metsas on vähemalt üks tühi ruut. Teisisõnu, leiduvad $0 \le i \lt N$ ja $0 \le j \lt N$, mille korral $F[i][j] = 0$.

## Alamülesanded

1. (6 punkti) Metsas on maksimaalselt üks ruut, milles on puu.
2. (8 punkti) $N \le 3$.
3. (22 punkti) $N \le 7$.
4. (18 punkti) $N \le 30$.
5. (16 punkti) $N \le 500$.
6. (30 punkti) Lisapiirangud puuduvad.

Igas alamülesandes on võimalik teenida 25% alamülesande väärtusest programmiga, mis suudab otsustada, kas *kõigi* tühjade ruutude hulk moodustab korrapärase staadioni.

Täpsemalt, igas testis, kus kõigi tühjade ruutude hulk moodustab korrapärase staadioni, saab lahendus
* täispunktid, kui funktsioon tagastab õige vastuse (mis sel juhul on tühjade ruutude arv);
* 0 punkti igal muul juhul.

Igas testis, kus kõigi tühjade ruutude hulk *ei moodusta* korrapärast staadioni, saab lahendus
* täispunktid, kui funktsioon tagastab õige vastuse;
* 0 punkti, kui funktsioon tagastab tühjade ruutude arvu;
* 25% punktidest, kui funktsioon tagastab mistahes muu väärtuse.

Lahenduse skoor iga alamülesande eest on selle alamülesande testide skooride miinimum.

## Hindamisprogramm

Arhiivis olev hindamisprogramm loeb sisendi järgmises vormingus:

* rida $1$: $N$
* rida $2 + i$ (kus $0 \le i \lt N$): $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$

Hindamisprogramm väljastab vastuse järgmises vormingus:

* rida $1$: funktsiooni `biggest_stadium` tagastatud väärtus
