# საფეხბურთო მოედანი

ნაგიერდო არის კვადრატის ფორმის ტყე, რომელიც შეგვიძლია წარმოვიდგინოთ, როგორც  $N \times N$ რაოდენობის უჯრისაგან შემდგარი მატრიცა.
მატრიცის სვეტები გადანომრილია $0$-დან $(N - 1)$-მდე დასავლეთიდან აღმოსავლეთისკენ, ხოლო სტრიქონები გადანომრილია $0$-დან $(N - 1)$-მდე ჩრდილოეთიდან სამხრეთისკენ.
$r$ სტრიქონსა და $c$ სვეტში განთავსებული უჯრა აღვნიშნოთ $(r, c)$-თი.

ტყეში თითოეული უჯრა შეიძლება იყოს **ცარიელი** ან შეიცავდეს **ხეს**.
მინიმუმ ერთი უჯრა არის ცარიელი.

DVSC, ცნობილი სპორტული კლუბი გეგმავს ტყეში ახალი საფეხბურთო მოედნის აშენებას.
$s$ ზომის სტადიონი (სადაც $s \ge 1$) შედგება $s$ ცალი *განსხვავებული ცარიელი* უჯრისგან $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$. სხვა სიტყვებით, თითოეული $i$-სთვის $0$-დან $(s - 1)$-ის ჩათვლით, უჯრა $(r_i, c_i)$ არის ცარიელი და თითოეული $i, j$-სათვის, სადაც $0 \le i \lt j \lt s$, სრულდება შემდეგი ტოლობებიდან ერთი მაინც: $r_i \neq r_j$, $c_i \neq c_j$.

ფეხბურთის სათამაშოდ გამოიყენება ბურთი, რომელიც გადაადგილდება სტადიონზე უჯრიდან უჯრაში.
**სწორი დარტყმა** ეწოდება შემდეგ ჩამოთვლილთაგან ერთ-ერთ ქმედებას:
* გადავაადგილოთ ბურთი უჯრა $(r,a)$-დან უჯრა $(r,b)$-მდე ($0 \le r,a,b \lt N, a \ne b$), სადაც სტადიონი მოიცავს *ყველა* უჯრას $(r,a)$-დან $(r,b)$-მდე სტრიქონ $r$-ში. ფორმალურად,
 - თუ $a \lt b$, მაშინ სტადიონი უნდა შეიცავდეს უჯრა $(r,k)$-ს, თითოეული $k$-სთვის, რომლისთვისაც  $a \le k \le b$,
 - თუ $a \gt b$, მაშინ სტადიონი უნდა შეიცავდეს უჯრა $(r,k)$-ს, თითოეული $k$-სთვის, რომლისთვისაც $b \le k \le a$.
* გადავაადგილოთ ბურთი უჯრა $(a,c)$-დან უჯრა $(b,c)$-მდე ($0 \le c,a,b \lt N, a \ne b$), სადაც სტადიონი შეიცავს *ყველა* უჯრას $(a,c)$-სა და $(b,c)$-ს შორის სვეტ $c$-ში. ფორმალურად,
 - თუ $a \lt b$, მაშინ სტადიონი უნდა შეიცავდეს უჯრა $(k,c)$-ს, თითოეული $k$-სთვის, რომლისთვისაც $a \le k \le b$,
 - თუ $a \gt b$, მაშინ სტადიონი უნდა შეიცავდეს უჯრა $(k,c)$-ს, თითოეული $k$-სთვის, რომლისთვისაც $b \le k \le a$.

სტადიონი არის **რეგულარული**, თუ შესაძლებელია ბურთის გადატანა სტადიონის ნებისმიერი უჯრიდან ამ სტადიონის სხვა უჯრამდე მაქსიმუმ $2$ სწორი დარტყმით.
შევნიშნოთ, რომ $1$ ზომის ნებისმიერი სტადიონი არის რეგულარული.

მაგალითისთვის, განვიხილოთ $N = 5$ ზომის ტყე, რომელშიც $(1,0)$ და $(4,2)$ შეიცავენ ხეებს და ყველა დანარჩენი უჯრა არის ცარიელი. ქვემოთ მოცემული სურათი აჩვენებს 3 შესაძლო სტადიონს. უჯრები, რომლებშიც ხეებია - გამუქებულია, ხოლო უჯრები, რომლებიც სტადიონის ნაწილია - დაშტრიხულია.
 
![Stadiums](soccer-regular.png "650")

სტადიონი მარცხენა სურათზე არის რეგულარული. სტადიონი შუა სურათზე არ არის რეგულარული, რადგან საჭიროა მინიმუმ $3$ სწორი დარტყმა ბურთის $(4,1)$-დან $(4,3)$-მდე მისატანად. მარჯვენა სტადიონი ასევე არ არის რეგულარული, რადგან შეუძლებელია სწორი დარტყმების გამოყენებით ბურთის მიტანა $(3,0)$-დან $(1,3)$-მდე.

სპორტულ კლუბს სურს ააშენოს მაქსიმალური შესაძლო ზომის მქონე რეგულარული სტადიონი. თქვენი ამოცანაა იპოვოთ მაქსიმალური მნიშვნელობა $s$, რომლისთვისაც არსებობს მოცემულ ტყეში $s$ ზომის რეგულარული სტადიონი.

## იმპლემენტაციის დეტალები
თქვენ იმპლემენტაცია უნდა გაუკეთოთ შემდეგ პროცედურას.

```
int biggest_stadium(int N, int[][] F)
```

* $N$: ტყის ზომა.
* $F$: $N$ ზომის მასივი შემდგარი $N$ ზომის მასივებისაგან, რომელიც აღწერს უჯრებს ამ ტყეში. თითოეული $r$ და $c$-სთვის, რომლისთვისაც $0 \le r \lt N$ და $0 \le c \lt N$, $F[r][c] = 0$ აღნიშნავს, რომ უჯრა $(r, c)$ არის ცარიელი, ხოლო $F[r][c] = 1$ აღნიშნავს, რომ უჯრა შეიცავს ხეს.
* პროცედურამ უნდა დააბრუნოს მაქსიმალური ზომა რეგულარული სტადიონისა, რომელიც შეიძლება აშენებული იქნას მოცემულ ტყეში.
* პროცედურა გამოძახებული იქნება ზუსტად ერთხელ თითოეული ტესტისათვის.

## მაგალითი

განვიხილოთ შემდეგი გამოძახება:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

ამ მაგალითისთვის ტყე გამოსახულია მარცხენა სურათზე, ხოლო $20$ ზომის რეგულარული სტადიონი გამოსახულია მარჯვენა სურათზე:

![Example](soccer-example.png "400")

რადგან არ არსებობს $21$ ან უფრო დიდი ზომის მქონე რეგულარული სტადიონი, პროცედურამ უნდა დააბრუნოს $20$.

## შეზღუდვები

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ (თითოეული $i$ და $j$-სათვის, რომლისთვისაც ($0 \le i \lt N$ და $0 \le j \lt N$)
* ტყეში არის მინიმუმ ერთი ცარიელი უჯრა. სხვა სიტყვებით, $F[i][j] = 0$ რომელიმე $0 \le i \lt N$ და $0 \le j \lt N$-სათვის.

## ქვეამოცანები

1. (6 ქულა) ტყეში არის მაქსიმუმ 1 ხე.
2. (8 ქულა) $N \le 3$
3. (22 ქულა) $N \le 7$ 
4. (18 ქულა) $N \le 30$ 
5. (16 ქულა) $N \le 500$
6. (30 ქულა) დამატებითი შეზღუდვების გარეშე.

თითოეული ქვეამოცანისთვის თქვენ შეგიძლიათ ნაწილობრივი ქულების მიღება, თუ თქვენი პროგრამა სწორად განსაზღვრავს არის თუ არა *ყველა* ცარიელი უჯრისგან შემდგარი სტადიონი რეგულარული.

უფრო ზუსტად, თითოეული ტესტისათვის, რომელშიც ყველა ცარიელი უჯრისაგან შედგენილი სიმრავლე წარმოადგენს რეგულარულ სტადიონს, თქვენი ამოხსნა:
* მიიღებს სრულ ქულას, თუ ის დააბრუნებს სწორ პასუხს (იმ სიმრავლის ზომას, რომელიც ყველა ცარიელი უჯრისაგან შედგება).
* მიიღებს 0 ქულას წინააღმდეგ შემთხვევაში.

თითოეული ტესტისათვის, რომლისთვისაც ყველა ცარიელი უჯრისაგან შედგენილი სიმრავლე *არ არის* რეგულარული სტადიონი, თქვენი ამოხსნა:
* მიიღებს სრულ ქულას, თუ დააბრუნებს სწორ პასუხს.
* მიიღებს 0 ქულას, თუ დააბრუნებს სიმრავლის ზომას, რომელიც ყველა ცარიელი უჯრისაგან შედგება.
* მიიღებს ქულების 25%-ს, თუ დააბრუნებს ნებისმიერ სხვა მნიშვნელობას.

ქულა თითოეული ქვეამოცანისათვის იქნება მინიმუმი ამ ქვეამოცანის ტესტებში მიღებულ ქულებს შორის.

## სანიმუშო გრადერი

სანიმუშო გრადერი შემომავალ მონაცემებს კითხულობს შემდეგი ფორმატით: 
 
* სტრიქონი $1$: $N$
* სტრიქონი $2 + i$  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
სანიმუშო გრადერი პასუხს ბეჭდავს შემდეგი ფორმატით:
* სტრიქონი $1$: `biggest_stadium`-ს მიერ დაბრუნებული მნიშვნელობა.
