# Soccer Stadium (γήπεδο ποδοσφαίρου)


Το Nagyerdő είναι ένα δάσος τετραγωνικού σχήματος που βρίσκεται στην πόλη Debrecen, το οποίο μπορεί να μοντελοποιηθεί ως ένα πλέγμα κελιών $N \times N$.
Οι γραμμές του πλέγματος αριθμούνται από $0$ έως $N - 1$ από βορρά προς νότο, και
οι στήλες αριθμούνται από $0$ έως $N - 1$ από τα δυτικά προς τα ανατολικά.
Αναφερόμαστε στο κελί που βρίσκεται στη γραμμή $r$ και στη στήλη $c$ του πλέγματος ως κελί $(r, c)$.

Στο δάσος, κάθε κελί είναι είτε **κενό** είτε περιέχει ένα **δέντρο**.
Τουλάχιστον ένα κελί στο δάσος είναι κενό.

Η DVSC, ο διάσημος αθλητικός σύλλογος της πόλης, σχεδιάζει να κατασκευάσει ένα νέο γήπεδο ποδοσφαίρου στο δάσος.
Ένα γήπεδο μεγέθους $s$ (όπου $s \ge 1$) είναι ένα σύνολο $s$ *διακριτών κενών* κελιών $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$.
Τυπικά αυτό σημαίνει:
- Για κάθε $i$ από $0$ έως $s - 1$, συμπεριλαμβανομένου, το κελί $(r_i, c_i)$ είναι κενό,
- για κάθε $i, j$ έτσι ώστε $0 \le i \lt j \lt s$, ισχύει τουλάχιστον ένα από τα $r_i \neq r_j$ και $c_i \neq c_j$.


Το ποδόσφαιρο παίζεται με μια μπάλα που κινείται στα κελιά του σταδίου.
Ως **ευθεία κλωτσιά** ορίζεται μία από τις ακόλουθες δύο ενέργειες:
* Μετακίνηση της μπάλας από το κελί $(r,a)$ στο κελί $(r,b)$ ($0 \le r,a,b \lt N, a \ne b$), όπου το στάδιο περιλαμβάνει *όλα* τα κελιά μεταξύ των κελιών $(r,a)$ και $(r,b)$ στη σειρά $r$. Τυπικά,
 - αν $a \lt b$ τότε το στάδιο πρέπει να περιέχει το κελί $(r,k)$ για κάθε $k$ τέτοιο ώστε $a \le k \le b$,
 - αν $a \gt b$ τότε το στάδιο θα πρέπει να περιέχει κελί $(r,k)$ για κάθε $k$ τέτοιο ώστε $b \le k \le a$.
* Μετακίνηση της μπάλας από το κελί $(a,c)$ στο κελί $(b,c)$ ($0 \le c,a,b \lt N, a \ne b$), όπου το στάδιο περιέχει *όλα* τα κελιά μεταξύ των κελιών $(a,c)$ και $(b,c)$ στη στήλη $c$. Τυπικά,
 - αν $a \lt b$ τότε το στάδιο θα πρέπει να περιέχει το κελί $(k,c)$ για κάθε $k$ τέτοιο ώστε $a \le k \le b$,
 - αν $a \gt b$ τότε το στάδιο θα πρέπει να περιέχει κελί $(k,c)$ για κάθε $k$ τέτοιο ώστε $b \le k \le a$.


Ένα γήπεδο είναι **κανονικό** αν  μπορεί να μετακινηθεί η μπάλα από οποιοδήποτε κελί του σταδίου σε οποιοδήποτε άλλο κελί του σταδίου με το πολύ $2$ ευθείες κλωτσιές.
Σημειώστε ότι κάθε στάδιο μεγέθους $1$ είναι κανονικό.

Για παράδειγμα, θεωρήστε ένα δάσος μεγέθους $N = 5$, με τα κελιά $(1,0)$ και $(4,2)$ να περιέχουν δέντρα και κάθε άλλο κελί να είναι κενό.
Το παρακάτω σχήμα δείχνει τρία πιθανά στάδια. Τα κελιά με τα δέντρα είναι σκουρόχρωμα και τα κελιά που περιέχονται από το στάδιο είναι ριγέ.

 
![Stadiums](soccer-regular.png "650")


Το γήπεδο στα αριστερά είναι κανονικό. Ωστόσο, το γήπεδο στο μέσο
δεν είναι κανονικό, επειδή απαιτούνται τουλάχιστον $3$ ευθείες κλωτσιές για να μετακινηθεί η μπάλα από κελί $(4,1)$ στο $(4,3)$. Το γήπεδο στα δεξιά δεν είναι επίσης κανονικό, επειδή είναι αδύνατο
να μετακινηθεί η μπάλα από το κελί $(3,0)$ στο $(1,3)$ με ευθείες κλωτσιές.

Ο αθλητικός σύλλογος θέλει να κατασκευάσει ένα κανονικό στάδιο που να είναι όσο το δυνατόν μεγαλύτερο.
Το έργο σας είναι να βρείτε τη μέγιστη τιμή του $s$ ώστε να υπάρχει ένα κανονικό στάδιο μεγέθους $s$ στο δάσος.

## Λεπτομέρειες υλοποίησης

Θα πρέπει να υλοποιήσετε την παρακάτω συνάρτηση.

```
int biggest_stadium(int N, int[][] F)
```

* $N$: το μέγεθος του δάσους.
* $F$: ένας πίνακας μήκους $N$ που περιέχει πίνακες μήκους $N$, οι οποίοι περιγράφουν τα κελιά του δάσους. Για κάθε $r$ και $c$ έτσι ώστε $0 \le r \lt N$ και $0 \le c \lt N$, $F[r][c] = 0$ σημαίνει ότι το κελί $(r, c)$ είναι κενό, και $F[r][c] = 1$ σημαίνει ότι περιέχει ένα δέντρο.
* Αυτή η συνάρτηση θα πρέπει να επιστρέφει τον μέγιστο μέγεθος ενός κανονικού σταδίου που μπορεί να κατασκευαστεί στο δάσος.
* Αυτή η συνάρτηση καλείται ακριβώς μία φορά για κάθε test case.

## Παράδειγμα

Έστω η ακόλουθη κλήση:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0],
                    [0, 0, 0, 0, 0],
                    [0, 0, 0, 0, 0],
                    [0, 0, 1, 0, 0]])
```

Σε αυτό το παράδειγμα, το δάσος εμφανίζεται στα αριστερά και ένα κανονικό στάδιο μεγέθους $20$ εμφανίζεται στα δεξιά (ακόλουθο σχήμα):

![Example](soccer-example.png "400")

Δεδομένου ότι δεν υπάρχει κανονικό στάδιο μεγέθους $21$ ή μεγαλύτερο, η συνάρτηση θα πρέπει να επιστρέψει $20$.

## Περιορισμοί

* $1 \le N \le 2\,000$
* $0 \le F[i][j] \le 1$ (για κάθε $i$ και $j$ έτσι ώστε $0 \le i \lt N$ και $0 \le j \lt N$)
* Υπάρχει τουλάχιστον ένα κενό κελί στο δάσος. Με άλλα λόγια, $F[i][j] = 0$ για κάποια $0 \le i \lt N$ και $0 \le j \lt N$.

## Υποπροβλήματα

1. (6 βαθμοί) Υπάρχει το πολύ ένα κελί που περιέχει ένα δέντρο.
2. (8 βαθμοί) $N \le 3$
3. (22 βαθμοί) $N \le 7$
4. (18 βαθμοί) $N \le 30$
5. (16 βαθμοί) $N \le 500$
6. (30 βαθμοί) Χωρίς επιπλέον περιορισμούς.


Σε κάθε υποπρόβλημα, μπορείτε να λάβετε το 25% της βαθμολογίας του υποπροβλήματος αν το πρόγραμμά σας κρίνει σωστά αν το σύνολο που αποτελείται από *όλα* τα κενά κελιά είναι ένα κανονικό στάδιο.

Πιο συγκεκριμένα, για κάθε test case στο οποίο το σύνολο που αποτελείται από όλα τα κενά κελιά είναι ένα κανονικό στάδιο, η λύση σας:
* παίρνει όλους τους βαθμούς αν επιστρέφει τη σωστή απάντηση (η οποία είναι το μέγεθος του συνόλου που αποτελείται από όλα τα κενά κελιά).
* παίρνει 0 πόντους σε αντίθετη περίπτωση.

Για κάθε test case στο οποίο το σύνολο που αποτελείται από όλα τα κενά κελιά *δεν* είναι κανονικό στάδιο, η λύση σας:
* παίρνει πλήρεις βαθμούς αν επιστρέφει τη σωστή απάντηση.
* παίρνει 0 βαθμούς αν επιστρέφει το μέγεθος του συνόλου που αποτελείται από όλα τα κενά κελιά.
* παίρνει το 25% των βαθμών αν επιστρέψει οποιαδήποτε άλλη τιμή.

Η βαθμολογία για κάθε υποπρόβλημα είναι το ελάχιστο των βαθμών για τα test cases του υποπροβλήματος.

## Ενδεικτικός Grader

Ο ενδεικτικός Grader διαβάζει την είσοδο με την ακόλουθη μορφή:
 
* Γραμμή $1$: $N$
* Γραμμή $2 + i$  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
Ο ενδεικτικός Grader εκτυπώνει την απάντησή σας με την ακόλουθη μορφή:
* Γραμμή $1$: η επιστρεφόμενη τιμή του `biggest_stadium`