# Foci stadion

Nagyerdő egy négyzet alakú erdő Debrecenben, amely $N \times $N -es négyzetráccsal modellezhető. Az oszlopok  $0$-től $N - 1$-ig sorszámozottak nyugtaról-keletre haladva, a sorok is $0$-től $N - 1$-ig sorszámozottak északról-délre haladva.Az $r$. sorban és $c$. oszlopban lévő cellára a  $(r, c)$ számpárral hivatkozunk.
Az erdőben minden cella vagy **üres**, vagy egy **fát** tartalmaz. Legalább egy cella üres az erdőben.

A város híres csapata a DVCSC az erdőben építendő új stadion építését tervezi. Egy $s$ (ahol $s \ge 1$) méretű stadion $s$ darab különböző üres cellából áll; $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$. Tehát minden $i$-re  $0$ és $s - 1$ között, az $(r_i, c_i)$ cella üres, és minden $i,j$-re amelyre  $i \lt j \lt s$, $r_i \neq r_j$ vagy $c_i \neq c_j$ teljesül.
A játékot úgy játszák, hogy egy labdát **egyenes rúgással** egy cellából egy másik cellába továbbítják. Az egyenes rúgás az alábbi kétféle lehet:
* A labda az  $(r,a)$ cellából az $(r,b)$ cellába kerül, ($0 \le r,a,b \lt N, a \ne b$), ahol a stadion az $r$. sorban minden cellát tartalmazza az  $(r,a)$ és $(r,b)$ cella között. Formálisan
 - Ha $a \lt b$, akkor a stadion minden $k$-ra tartalmazza  az $(r,k)$ cellát, ha $a \le k \le b$,
 - Ha $a \gt b$, akkor a stadion minden $k$-ra tartalmazza az $(r,k)$ cellát, ha   $b \le k \le a$.
* A labda az $(a,c)$ cellából a $(b,c)$ ($0 \le c,a,b \lt N, a \ne b$) cellába kerül, és a stadion a $c$. oszlop minden cellát tartalmazza az $(a,c)$ és $(b,c)$  cella között. Formálisan
 - Ha $a \lt b$, akkor a stadion minden $k$-ra tartalmazza a  $(k,c)$ cellát, ha $a \le k \le b$,
 - Ha $a \gt b$, akkor a stadion minden $k$-ra tartalmazza a $(k,c)$ cellát, ha    $b \le k \le a$.
A stadiont **szabályos**, ha bármely cellájából bármely másik cellába továbbítani lehet a labdát legfeljebb 2 egyenes rúgással. Megjegyezzük, hogy minden 1 méretű (egy cellát tartalmazó) stadion szabályos.

Pédául, tekintsük azt az $N = 5$ méretű erdőben, amely csak az $(1,0)$ és $(4,2)$ cellában tartalmaz csak fát. Az ábra három lehetséges stadiont mutat, a stadion cellái a satírozottak. 

![Stadiums](soccer-regular.png "650")
A bal oldali station szabályos, de a középső nem, mert a labdát csak legalább 3 egyenes rúgással lehet továbbítani a
 $(4,1)$ cellából a $(4,3)$ cellába. a jobboldali station szintén nem szabályos, mert nem lehet  $(3,0)$-ból $(1,3)$-be továbbítani a labdát.

A sport klub a lehető legynagobb méretű szabályos stadiont akarja megépíteni.
Számítsd ki az a legnagyobb $s$ értéket, amelyre teljül, hogy építható $s$ méretű szabályos stadion.

## Megvalósítás

Az alábbi függvényt kell megvalósítanod.

```
int biggest_stadium(int N, int[][] F)
```

* $N$: az erdő mérete.
* $F$:  $N$ méretű tömb, amelynek minden eleme egy $N$ méretű tömb, amely megadja az erdőt. Minden $r$ és  $c$ értékre, ahol  $0 \le r \lt N$ és $0 \le c \lt N$, $F[r][c] = 0$ azt jeleni, hogy  az  $(r, c)$cella üres,  $F[r][c] = 1$ pedig azt jelenti, hogy a cella fát tartalmaz. 
* A függvény visszatérési éertéke a legnagyobb szabályos stadion mérete legyen!
* A függvényt minden tesztesetre pontosan egyszer hívja az értékelő.

## Példa

Tekintsük az alábbi függvényhívást:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

Az erdőt a baloldali kép mutatja, a jobboldali kép pedig egy $20$ méretű szabályos stadiont mutat, amely a lehető legnagyobb:

![Example](soccer-example.png "400")

Tehát a függvény a $20$ értéket adja vissza.

## Feltételek

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ (for each $i$ and $j$ such that $0 \le i \lt N$ and $0 \le j \lt N$)
* There is at least one empty cell in the forest. In other words, $F[i][j] = 0$ for some $0 \le i \lt N$ and $0 \le j \lt N$.

## Részfeladatok

1. (6 pont) Legfeljebb egy cella tartalmaz fát.
2. (8 pont) $N \le 3$
3. (22 pont) $N \le 7$ 
4. (18 pont) $N \le 30$ 
5. (16 pont) $N \le 500$
6. (30 pont) Nincs egyéb feltétel.

Minden részfeladat esetén részpontot is kaphatsz. 
Minden tesztesetben, ha az összes üres cella szabályos staiont alkot, akkor a helyes megoldásod az alábbiak szerint kap pontot:
* teljes pontszámot kapsz, ha a megoldásod az üres cellák számát adja,
*  0 pontot egyébként.

Minden tesztesetben, ha az összes üres cella *nem* szabályos staiont alkot, akkor a megoldásod az alábbiak szerint kap pontot:
* teljes pontszámot kapsz, ha helyes a megoldásod,
* 0 pontot kapsz, ha megoldásod értéke az összes üres cella száma,
* a teljes pontszám 25%-át kapod, ha a fentiektől eltérő, de tetszőleges értéket ad a megoldásod.

Minden részfeladatra a pontszámod a tesztesetekre kapott pontok minimuma..

## Mintaértékelő

A mintaértékelő az alábbi formában olvassa be a bemenetet: 
 
*  $1$. sor: $N$
*  $2 + i$. sor  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
 A mintaértékelő a megoldásod értékét az alábbi formában írja ki:
* l$1$. sor:  `biggest_stadium` függvény vissatérési értéke.
