#  استادیوم فوتبال

ناگیردو یک جنگل مربعی شکل در شهر دیبریسن است که با یگ گرید $N \times N$ مدل شده است. سطرهای گرید از شمال به جنوب از $0$ تا $N-1$  و ستون‌های گرید از غرب به شرق از $0$ تا $N-1$ شماره‌گذاری شده ‌اند. سلولی که در ردیف $r$ و ستون $c$ قرار گرفته است با $(r, c)$ نمایش داده می‌شود.

در جنگل هر سلول یا خالی است یا با یک درخت اشغال شده است. حداقل یک سلول خالی در جنگل موجود است.

دی‌وی‌اس‌سی، باشگاه ورزشی مشهور شهر، می‌خواهد یک استادیوم فوتبال در جنگل احداث کند. یک استادیوم به اندازه $s$ (که $s \geq 1$) مجموعه‌ای از $s$ سلول خالی و متمایز $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$  است. این بطور رسمی به این معنی است که: 
* به ازای هر $i$ از $0$  تا $s-1$ (شامل هر دو)  سلول $(r_i, c_i)$  خالی است،
*   برای هر $i, j$ بطوری که $0\leq i \lt j \lt s$، حداقل یکی از رابطه  $r_i \neq r_j$ یا $c_i \neq c_j$ برقرار است.

فوتبال با توپی بازی می‌شود که در سلول‌های استادیوم حرکت می‌کند.  به هر یک  از دو عمل زیر یک شوت مستقیم گفته می‌شود:
* حرکت دادن توپ از سلول $(r,a)$ به سلول $(r,b)$ ($0 \le r,a,b \lt N, a \ne b$) به شرط انکه همه سلول‌ها در ردیف $r$ام از سلول $(r,a)$ تا $(r,b)$ متعلق به استادیوم باشد. بطور رسمی یعنی:
   - اگر  $a \lt b$، استادیوم باید شامل همه سلول‌های $(r,k)$  باشد که  $a \le k \le b$،
   - اگر $a \gt b$، استادیوم باید شامل همه سلول‌های $(r,k)$ باشد که $b \le k \le a$.
* حرکت دادن توپ از سلول $(a,c)$ به سلول $(b,c)$ ($0 \le c,a,b \lt N, a \ne b$) به شرط انکه همه سلول‌های واقع در ستون $c$ از سلول $(a,c)$ تا $(b,c)$ متعلق به استادیوم باشد. بطور رسمی یعنی:
   - اگر  $a \lt b$، استادیوم باید شامل همه سلول‌های $(k,c)$  باشد که  $a \le k \le b$،
   - اگر $a \gt b$، استادیوم باید شامل همه سلول‌های $(k,c)$ باشد که $b \le k \le a$.

یک استادیوم منظم است اگر بتوان توپ را از هر سلول استادیوم به هر سلول دیگر استادیوم با حداکثر دو شوت مستقیم  رساند.  دقت کنید هر استادیوم با اندازه یک منظم است.

برای نمونه، جنگلی به اندازه $N = 5$  را در نظر بگیرید که در سلول‌های $(1,0)$ و $(4,2)$ درخت قرار دارد و بقیه سلول‌ها خالی است.  شکل زیر سه استادیوم ممکن را نمایش می‌دهد. سلول‌های شامل درخت با رنگ سیاه نمایش داده شده است و سلول‌های استادیوم بصورت نواری  شکل نمایش داده شده‌است. 

![Stadiums](soccer-regular.png "650")

استادیوم سمت چپ منظم است اما استادیوم وسط منظم نیست چرا که حداقل سه شوت مستقیم برای حرکت دادن توپ از سلول $(4,1)$ به سلول $(4,3)$ نیاز است. استادیوم سمت راست نیز منظم نیست، چرا که امکان‌پذیر نیست توپ را از سلول $(3,0)$ به سلول $(1,3)$ با شوت‌های مستقیم رساند.

باشگاه ورزشی دنبال ساخت یک استادیوم منظم با بزرگترین اندازه ممکن است. وظیفه شما آن است که بزرگ‌ترین مقدار $s$  را پیدا کنید که یک استادیوم به اندازه $s$ بتوان در جنگل ساخت.

## Implementation Details

You should implement the following procedure.

```
int biggest_stadium(int N, int[][] F)
```

* $N$: the size of the forest.
* $F$: an array of length $N$ containing arrays of length $N$, describing cells in the forest. For each $r$ and $c$ such that $0 \le r \lt N$ and $0 \le c \lt N$, $F[r][c] = 0$ means that cell $(r, c)$ is empty, otherwise $F[r][c] = 1$ means that it contains a tree.
* This procedure should return the maximum size of a regular stadium that can be built in the forest.
* This procedure is called exactly once for each test case.

## Example

Consider the following call:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

In this example, the forest is displayed on the left and a regular stadium of size $20$ is displayed on the right of the following figure:

![Example](soccer-example.png "400")

Since there is no regular stadium of size $21$ or greater, the procedure should return $20$.

## Constraints

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ (for each $i$ and $j$ such that $0 \le i \lt N$ and $0 \le j \lt N$)
* There is at least one empty cell in the forest. In other words, $F[i][j] = 0$ for some $0 \le i \lt N$ and $0 \le j \lt N$.

## Subtasks

1. (6 points) There is at most one cell containing a tree.
2. (8 points) $N \le 3$
3. (22 points) $N \le 7$ 
4. (18 points) $N \le 30$ 
5. (16 points) $N \le 500$
6. (30 points) No additional constraints.

In each subtask, you can obtain a partial score
if your program judges correctly whether the subset consisting of *all* the empty cells is a regular stadium.

More precisely, for each testcase in which the subset consisting of all the empty cells is a regular stadium, your solution:
* gets full points if it returns the correct answer (which is the size of the subset consisting of all the empty cells).
* gets 0 points otherwise.

For each testcase in which which the subset consisting of all the empty cells is *not* a regular stadium, your solution:
* gets full points if it returns the correct answer.
* gets 0 points if it returns the size of the subset consisting of all the empty cells.
* gets 25% of the points if it returns any other value.

The score for each subtask is the minimum of the points for the test cases in the subtask.

## Sample Grader

The sample grader reads the input in the following format: 
 
* line $1$: $N$
* line $2 + i$  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
The sample grader prints your answer in the following format:
* line $1$: the return value of `biggest_stadium`






