# אצטדיון כדורגל
נאירדו הוא יער ריבועי הנמצא בעיר דברצן, אותו ניתן למדל כטבלה בגודל $N \times N$ של תאים.
שורות הטבלה ממוספרות מ-$0$ עד $N-1$ מצפון לדרום, ועמודות הטבלה ממוספרות מ-$0$ עד $N-1$ ממערב למזרח.
נתייחס לתא בשורה $r$ ובעמודה $c$ של הטבלה בתור התא $(r,c)$.

ביער, כל תא הוא או **ריק** או מכיל **עץ**. לפחות אחד מהתאים ביער הוא ריק.

דברצן ו.ס.ק, מועדון הספורט המפורסם של העיר, מתכנן לבנות אצטדיון כדורגל חדש ביער.
אצטדיון מגודל $s$ (כאשר $s \geq 1$) זו קבוצה של $s$ תאים *ריקים שונים* $(r_0, c_0), \ldots, (r_{s-1}, c_{s-1})$. פורמלית המשמעות היא:
 - לכל $i$ מ-$0$ עד $s-1$, כולל, התא $(r_i, c_i)$ הוא ריק.
 - לכל $i, j$ המקיימים $0\leq i < j < s$, לפחות אחד מבין $r_i \neq r_j$ ו-$c_i \neq c_j$ מתקיים.

כדורגל משוחק באמצעות כדור שמזיזים בין תאי האצטדיון.
**בעיטה ישרה** מוגדרת להיות אחת מבין שתי הפעולות הבאות:
* הזזת הכדור מהתא $(r,a)$ לתא $(r,b)$ ($0 \le r,a,b, \lt N, a \neq b$), כאשר האצטדיון מכיל את *כל* התאים בין $(r,a)$ ל-$(r,b)$ בשורה $r$. פורמלית, 
 - אם $a \lt b$ אז האצטדיון צריך לכלול את כל התאים $(r,k)$ לכל $k$ המקיים $a \le k \le b$
 - אם $a \gt b$ אז האצדיון צריך לכלול את כל התאים $(r,k)$ לכל $k$ המקיים $b \le k \le a$ 
* הזזת הכדור מהתא $(a,c)$ לתא $(b,c)$ ($0 \le r,a,b, \lt N, a \neq b$), כאשר האצטדיון מכיל את *כל* התאים בין $(a,c)$ ל-$(b,c)$ בשורה $c$. פורמלית, 
 - אם $a \lt b$ אז האצטדיון צריך לכלול את כל התאים $(k,c)$ לכל $k$ המקיים $a \le k \le b$
 - אם $a \gt b$ אז האצטדיון צריך לכלול את כל התאים $(k,c)$ לכל $k$ המקיים $b \le k \le a$

אצטדיון הוא **רגולרי** אם אפשרי להזיז את הכדור מכל תא באצטדיון לכל תא אחר באצטדיון באמצעות לכל היותר $2$ בעיטות ישרות. שימו לב שכל אצטדיון מגודל $1$ הוא רגולרי.

לדוגמה, התבוננו ביער מגודל $N=5$, כשהתאים $(1,0)$ ו-$(4,2)$ מכילים עצים וכשכל שאר התאים ריקים.
האיור למטה מציג שלושה אצטדיונים אפשריים. תאים עם עצים הם מושחרים, ותאים שהאיצטדיון מכיל הם מפוספסים.
 
![Stadiums](soccer-regular.png "650")

האצטדיון בצד שמאל הוא רגולרי. לעומת זאת, האצטדיון באמצע הוא לא רגולרי, כי דרושות לפחות $3$ בעיטות ישרות כדי להזיז את הכדור מהתא $(4,1)$ ל-$(4,3)$. האצטדיון מימין גם הוא לא רגולרי, כי אי אפשר להזיז את הכדור מהתא $(3,0)$ ל-$(1,3)$ באמצעות בעיטות ישרות.

מועדון הספורט רוצה לבנות אצטדיון רגולרי גדול ככל הניתן.
משימתכם היא למצוא את הערך המקסימלי של $s$ כך שקיים אצטדיון רגולרי מגודל $s$ ביער.

## פרטי מימוש

עליכם לממש את הפונקציה הבאה:
```
int biggest_stadium(int N, int[][] F)
```


* $N$: גודל היער.
* $F$: מערך באורך $N$ שמכיל מערכים באורך $N$, שמתארים תאים ביער. לכל $r$ ו-$c$ המקיימים $0 \le r \lt N$
 ו-$0 \le c \lt N $
 , $F[r][c]=0$ משמעו שהתא $(r,c)$ הוא ריק, ו-$F[r][c]=1$ משמעו שהתא $(r,c)$ מכיל עץ.
*  על פונקציה זו להחזיר את הגודל המקסימלי של אצטדיון רגולרי שיכול להיבנות ביער.
*  פונקציה זו תיקרא פעם אחת בדיוק לכל טסטקייס.


## דוגמה

התבוננו בקריאה הבאה:
```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

בדוגמה הזאת, היער מוצג בצד שמאל ואצטדיון רגולרי מגודל $20$ מוצג בצד ימין של האיור הבא:

![Example](soccer-example.png "400")

מכיוון שאין אצטדיון רגולרי מגודל $21$ או יותר, על הפונקציה להחזיר $20$.

## מגבלות

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ (לכל $i$ ו-$j$ המקיימים $0 \le i \lt N$ ו-$0 \le j \lt N$)
* יש לפחות תא ריק אחד ביער. במילים אחרות, $F[i][j]=0$ עבור $0 \le i \lt N$ ו-$0 \le j \lt N$ כלשהם.

## תתי משימות

1. (6 נקודות) יש לכל היותר תא אחד שמכיל עץ.
2. (8 נקודות) $N \le 3$
3. (22 נקודות) $N \le 7$ 
4. (18 נקודות) $N \le 30$ 
5. (16 נקודות) $N \le 500$
6. (30 נקודות) ללא מגבלות נוספות.

בכל תת משימה, ניתן לקבל 25% מהניקוד של תת המשימה אם התוכנית שלכם תקבע באופן נכון האם הקבוצה שכוללת את *כל* התאים הריקים היא אצטדיון רגולרי.

ליתר דיוק, לכל טסטקייס שבו הקבוצה של כל התאים הריקים היא אצטדיון רגולרי, הפתרון שלכם:
 * יקבל ניקוד מלא אם יחזיר את התשובה הנכונה (שהיא הגודל של הקבוצה שכוללת את כל התאים הלא ריקים).
 * יקבל 0 נקודות אחרת.

לכל טסטקייס שבו הקבוצה של כל התאים הריקים היא *לא* אצטדיון רגולרי, הפתרון שלכם:
 * יקבל ניקוד מלא אם יחזיר את התשובה הנכונה.
 * יקבל 0 נקודות אם יחזיר את הגודל של הקבוצה שכוללת את כל התאים הריקים.
 * יקבל 25% מהנקודות אם הוא יחזיר כל ערך אחר.

הניקוד של תת המשימה הוא הניקוד המינימלי של טסטקייס בתת המשימה.

## גריידר לדוגמה

הגריידר לדוגמה קורא את הקלט בפורמט הבא:

* שורה $1$: $N$
* שורה $2 + i$  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
 הגריידר לדוגמה מדפיס את התשובה שלכם בפורמט הבא:
 * שורה $1$: ערך החזרה של `biggest_stadium`.






