# Soccer Stadium
Nagyerdő — Дебрецен қаласында орналасқан шаршы пішінді орман, оны $N \times N$ ұяшықтар торы ретінде қарастыруға болады.
Тордың бағандары батыстан шығысқа қарай $0$-дан $N - 1$-ға дейін және жолдар солтүстіктен оңтүстікке қарай $0$-дан $N - 1$-ға дейін нөмірленеді.
Тордың $r$ жолы мен $c$ бағанында орналасқан ұяшықты $(r, c)$ ұяшығы деп атаймыз.

Орманда әрбір ұяшықта **ағаш** болады  немесе ол **бос** болады.
Орманда кем дегенде бір ұяшық бос.

Қаланың атақты спорт клубы DVSC орманда жаңа футбол стадионын салуды жоспарлап отыр.
$s$ өлшемді стадион (мұндағы $s \ge 1$) $s$ *әртүрлі бос*  $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$ ұяшықтар жинағынан тұрады.
Яғни, $0$ бастап $s - 1$ қоса алғанда әрбір $i$ үшін $(r_i, c_i)$ ұяшығы бос және әрбір $j$ үшін $i \lt j \lt s$, $ r_i \neq r_j$ немесе $c_i \neq c_j$ орындалады.

Футбол стадионның ұяшықтарының айналасында қозғалатын доптың көмегімен ойналады.
**тура соққы** келесі екі әрекеттің бірі ретінде анықталады:
* Допты $(r,a)$ ұяшығынан $(r,b)$ ұяшығына жылжыту ($0 \le r,a,b \lt N, a \ne b$), мұнда $r$ жолындағы $(r,a)$ және $(r,b)$ ұяшығы арасындағы *барлық* ұяшықтар стадионда  бар. Ресми түрде,
  - егер $a \lt b$ болса, стадионда әрбір $a \le k \le b$ болатын $k$ үшін $(r,k)$ ұяшығы стадионда болуы керек,
  - егер $a \gt b$ болса, стадионда әрбір $b \le k \le a$ болатын $k$ үшін $(r,k)$ ұяшығы стадионда болуы керек.
* Допты $(a,c)$ ұяшығынан $(b,c)$ ұяшығына жылжыту ($0 \le c,a,b \lt N, a \ne b$), мұнда $c$ бағанындағы $(a,c)$ және $(b,c)$ ұяшықтары арасындағы *барлық* ұяшықтар стадионда бар. Ресми түрде,
  - егер $a \lt b$ болса, стадионда әрбір $a \le k \le b$ болатын $k$ үшін $(k,c)$ ұяшығы стадионда болуы керек,
  - егер $a \gt b$ болса, стадионда әрбір $b \le k \le a$ болатын $k$ үшін $(k,c)$ ұяшығы стадионда болуы керек.

Стадион **тұрақты** болып табылады, егер допты стадиондағы кез келген ұяшықтан стадиондағы кез келген басқа ұяшыққа ең көбі $2$ тура соққымен жылжыту мүмкін болса.
$1$ көлеміндегі кез келген стадион тұрақты екенін ескеріңіз.

Мысалы, $(1,0)$ және $(4,2)$ ұяшықтарында ағаштар және барлық басқа ұяшықтар бос болатын $N = 5$ өлшеміндегі орманды қарастырайық.
Төмендегі суретте үш ықтимал стадион көрсетілген. Ағаштары бар ұяшықтар қараңғыланып, стадиондағы ұяшықтар жолақты.
 
![Stadiums](soccer-regular.png "650")

Сол жақтағы стадион тұрақты. Ортадағы стадион тұрақты емес, себебі допты $(4,1)$ ұяшығынан $(4,3)$ ұяшығына жылжыту үшін кем дегенде $3$ тура соққы қажет. Оң жақтағы стадион да тұрақты емес, өйткені $(3,0)$ ұяшығынан $(1,3)$ ұяшығына допты тура соққылар арқылы жылжыту мүмкін емес.

Спорт клубы мүмкіндігінше үлкен тұрақты стадион салғысы келеді.
Сіздің міндетіңіз - орманда $s$ өлшемді тұрақты стадион болатындай $s$тің максималды мәнін табу.

## Implementation Details

Cізге келесі функцияны іске асыру қажет:

```
int biggest_stadium(int N, int[][] F)
```

* $N$: орманның өлшемі.
* $F$: ормандағы ұяшықтарды сипаттайтын $N$ ұзындықтағы массивтерді қамтитын $N$ ұзындығы массив. Әрбір $0 \le r \lt N$ және $0 \le c \lt N$ үшін $F[r][c] = 0$ деген $(r, c)$ ұяшығы бос екенің, әйтпесе $F[r][c] = 1$ оның құрамында ағаш бар екенін білдіреді.
* Бұл функция орманда салынуы мүмкін тұрақты стадионның максималды өлшемін қайтаруы керек.
* Бұл функция әрбір тест үшін бір рет шақырылады.
## Example

Келесі шақыруды қарастырайық:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

Бұл мысалда орман сол жақта және келесі суреттің оң жағында $20$ мөлшеріндегі тұрақты стадион көрсетілген:

![Example](soccer-example.png "400")

$21$ немесе одан үлкен тұрақты стадион болмағандықтан, функция $20$ қайтаруы керек.

## Constraints

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ ($0 \le i \lt N$ және $0 \le j \lt N$ болатын кез келген $i$ және $j$ үшін)
* Кем дегенде бір бос ұяшық бар. Басқаша айтқанда $F[i][j] = 0$ болатын $0 \le i \lt N$ және $0 \le j \lt N$ табылады.

## Subtasks

1. (6 points) Көп дегенде бір ұяшықта ағаш болады.
2. (8 points) $N \le 3$
3. (22 points) $N \le 7$ 
4. (18 points) $N \le 30$ 
5. (16 points) $N \le 500$
6. (30 points) Қосымша шектеулер жоқ.

Бағдарлама *барлық* бос ұяшықтардан тұратын жиынның тұрақты стадион болып табылатынын дұрыс бағаласа, әрбір бөлімшеді қосалқы тапсырма ұпайының 25% алуға болады.

Дәлірек айтқанда, барлық бос ұяшықтардан тұратын жиынтық тұрақты стадион болып табылатын әрбір сынақ жағдайы үшін сіздің шешіміңіз:
* дұрыс жауапты қайтарса, толық ұпай алады (бұл барлық бос ұяшықтардан тұратын жиынның өлшемі).
* әйтпесе 0 ұпай алады.

Барлық бос ұяшықтардан тұратын жинақ тұрақты стадион *болмайтын* әрбір сынақ жағдайы үшін сіздің шешіміңіз:
* дұрыс жауапты қайтарса, толық ұпай алады.
* барлық бос ұяшықтардан тұратын жиынның өлшемін қайтарса, 0 ұпай алады.
* кез келген басқа мәнді қайтарса, ұпайлардың 25% алады.

Әрбір бөлімшенің ұпайы - бұл бөлімшедегі сынақ жағдайлары үшін ұпайлардың ең азы.

## Sample Grader

Үлгі бағалаушы енгізбен келесі форматта оқиды:

* жол $1$: $N$
* жол $2 + i$  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
Үлгі бағалаушы жауаптарыңызды келесі форматта шығарады:
* жол $1$: `biggest_stadium` мәнің қайтарады