# Футбол стадиону

Надьердө — Дебрецен шаарында жайгашкан чарчы формадагы токой, аны $N \times N$ торчо клеткалары катары моделдесе болот.
Тордун катарлары түндүктөн түштүккө $0$дөн $(N - 1)$ге чейин номерленген жана
мамычалар батыштан чыгышка карай $0$дөн $(N - 1)$ге чейин номерленген.
Тордун $r$ сабында жана $c$ тилкесинде жайгашкан клетканы $(r, c)$ клеткасы деп атайбыз.

Токойдо ар бир клетка **бош** же **даракты** камтыйт.
Токойдо жок дегенде бир клетка бош.

Шаардын атактуу DVSC спорт клубу  токойго жаңы футбол стадионун курууну пландап жатат.
$s$ өлчөмүндөгү стадион (мында $s \ge 1$) $s$ *өзгөчө бош* клеткалардын жыйындысы $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$.
Бул расмий түрдө билдирет:
- $0$дөн $(s - 1)$ге чейинки ар бир $i$ үчүн, анын ичинде $(r_i, c_i)$ клеткасы бош,
- ар бир $i, j$ үчүн $0 \le i \lt j \lt s$, $r_i \neq r_j$ жана $c_i \neq c_j$лардын жок дегенде бирөөсү туура келет.

Футбол стадиондун камераларын айланып өтүүчү топтун жардамы менен ойнолот.
**Түз тебүү** төмөнкү эки аракеттин бири катары аныкталат:
* Топту $(r,a)$ клеткасынан $(r,b)$ ($0 \le r,a,b \lt N, a \ne b$) клеткасына жылдырыңыз, анда стадиондо *бардык* клеткалар бар $r$ катарындагы $(r,a)$ жана $(r,b)$ клеткаларынын ортосунда. Расмий түрдө,
  - эгерде $a \lt b$ болсо, анда стадиондо ар бир $k$ үчүн $(r,k)$клеткалары камтылууга тийиш, мынчалык $a \le k \le b$,
  - эгерде $a \gt b$ болсо, анда стадиондо ар бир $k$ үчүн $(r,k)$ клеткалары болушу керек, мынчалык $b \le k \le a$.
* Топту $(a,c)$ клеткасынан $(b,c)$ ($0 \le c,a,b \lt N, a \ne b$) клеткасына жылдырыңыз, мында стадиондо *бардык* клеткалар бар $c$ тилкесиндеги $(a,c)$ жана $(b,c)$ клеткаларынын ортосунда. Расмий түрдө,
  - эгерде $a \lt b$ болсо, анда стадиондо ар бир $k$ үчүн $(k,c)$ клеткалары болушу керек, мынчалык $a \le k \le b$,
  - эгерде $a \gt b$ болсо, анда стадиондо ар бир $k$ үчүн $b \le k \le a$ үчүн $(k,c)$ клеткалары болушу керек.

Стадион **жакшы** болуп саналат, эгерде ал камтылган каалаган клеткадан топту жылдыруу мүмкүн болсо
Стадиондун башка камерасына эң көп дегенде $2$ түз сокку менен.
$1$ өлчөмүндөгү ар кандай стадион **жакшы** экенин эске алыңыз.

Мисалы, $N = 5$ өлчөмүндөгү токойду карап көрөлү, $(1,0)$ жана $(4,2)$ клеткаларында бак-дарактар жана башка клеткалардын баары бош.
Төмөнкү сүрөттө үч мүмкүн болгон стадион көрсөтүлгөн. Бак-дарактары бар клеткалар караңгылатылган, ал эми стадиондогу камералар чаар-чаар менен капталган.

![Stadiums](soccer-regular.png "650")

Сол жактагы стадион **жакшы**. Бирок
ортодогу стадион **жакшы эмес** , анткени топту $(4,1)$ клеткасынан $(4,3)$ клеткасына чейин кеминде $3$ түз сокку керек. Оң жактагы стадион да **жакшы эмес** эмес, анткени топту $(3,0)$ клеткасынан $(1,3)$клеткасына түз соккуларды колдонуу менен жылдыруу мүмкүн эмес.

Спорт клубу мүмкүн болушунча чоң стадионду курууну каалайт.
Сиздин милдетиңиз токойдо $s$ өлчөмүндөгү **жакшы** стадион бар  болушу үчүн $s$нын максималдуу маанисин табуу.

## Процедуранын чоо-жайы

Сиз төмөнкү процедураны ишке ашырууңуз керек:

```
int bigest_stadium(int N, int[][] F)
```

* $N$: токойдун өлчөмү.
* $F$: токойдогу клеткаларды сүрөттөгөн $N$ узундуктагы массивдерди камтыган $N$ узундуктагы массив. Ар бир $r$ жана $c$ үчүн $0 \le r \lt N$ жана $0 \le c \lt N$, $F[r][c] = 0$ болсо $(r, c)$ клеткасын бош, ал эми $F[r][c] = 1$ болсо ал даракты камтыйт дегенди билдирет.
* Бул процедура токойдо курула турган **жакшы** стадиондун максималдуу өлчөмүн кайтарып бериши керек.
* Бул процедура ар бир сыноо учуру үчүн бир жолу чакырылат.



## Мисал

Төмөнкү чакырууну карап көрөлү:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

Бул мисалда, токой сол жагында көрсөтүлөт жана төмөнкү сүрөттүн оң жагында $20 $ өлчөмүндөгү жакшы стадион көрсөтүлгөн:

![Example](soccer-example.png "400")

$21$ же андан чоңураак жакшы стадион жок болгондуктан, процедура $20$ кайтарылышы керек.

## Чектөөлөр

* $1 \le N \le 2\,000$
* $0 \le F[i][j] \le 1$ (ар бир $i$ жана $j$ үчүн $0 \le i \lt N$ жана $0 \le j \lt N$)
* Токойдо жок дегенде бир бош клетка бар. Башкача айтканда, кээ бир $0 \le i \lt N$ жана $0 \le j \lt N$ үчүн $F[i][j] = 0$.


## Кошумча тапшырмалар

1. (6 упай) Даракты камтыган эң көп бир клетка бар.
2. (8 упай) $N \le 3$
3. (22 упай) $N \le 7$
4. (18 упай) $N \le 30$
5. (16 упай) $N \le 500$
6. (30 упай) Кошумча чектөөлөр жок.

Ар бир кошумча тапшырмада, программаңыз *бардык* бош клеткалардан турган топтом жакшы стадион экенине туура баа берсе, кошумча тапшырманын упайынын 25%ин ала аласыз.

Тагыраак айтканда, бардык бош клеткалардан турган комплект жакшы стадион болгон ар бир сыноо иши үчүн сиздин чечимиңиз:
* туура жоопту кайтарса, толук упай алат (бул бардык бош клеткалардан турган топтомдун өлчөмү).
* болбосо 0 упай алат.

Бардык бош уячалардан турган комплект кадимки стадион * эмес* болгон ар бир сыноо учуру үчүн сиздин чыгарылышыңыз:
* туура жооп кайтарса, толук упай алат.
* бардык бош клеткалардан турган топтомдун өлчөмүн кайтарса, 0 упай алат.
* Эгер башка маанини кайтарса, упайлардын 25%ин алат.

Ар бир кошумча тапшырманын упайы – бул кошумча тапшырмадагы тесттик иштердин минималдуу баллы.

## Үлгү Грейдер

Үлгү грейдер киргизүүнү төмөнкү форматта окуйт:
 
* $1$- сап: $N$
* кийинки $(2 + i) $- саптар ($0 \le i \lt N$): $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
Үлгү грейдер жообуңузду төмөнкү форматта басып чыгарат:
* $1$ - сап: `biggest_stadium` кайтарылган мааниси
