# Futbolo stadionas

Nagyerdő yra kvadrato formos miškas Debreceno mieste, kurį galima pavaizduoti $N \times N$ langelių lentele.
Lentelės eilutės sunumeruotos nuo $0$ iki $N - 1$ iš šiaurės į pietus, o stulpeliai sunumeruotos nuo $0$ iki $N - 1$ iš vakarų į rytus.
Langelį, esantį $r$-oje eilutėje ir $c$-ame stulpelyje, žymėsime $(r, c)$.

Miške kiekvienas langelis yra arba **tuščias**, arba jame yra **medis**.
Bent vienas langelis miške yra tuščias.

DVSC, garsus miesto sporto klubas, planuoja miške statyti naują futbolo stadioną.
$s$ dydžio stadionas (kur $s \ge 1$) yra sudarytas iš $s$ *skirtingų tuščių* langelių $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$.
Tai yra: 
* kiekvienam $i$ nuo $0$ iki $s - 1$ imtinai langelis $(r_i, c_i)$ yra tuščias,
* visiems $i,j$, kuriems galioja $0 \le i \lt j \lt s$, taip pat galioja bent vienas iš $r_i \neq r_j$ ir $c_i \neq c_j$.

Futbolas žaidžiamas su kamuoliu, kuris juda stadiono langeliais.
**Tiesus spyris** yra apibrėžtas kaip vienas iš šių veiksmų:
* Kamuolys iš langelio $(r,a)$ nuspiriamas į langelį $(r,b)$ ($0 \le r,a,b \lt N, a \ne b$), o stadionui priklauso *visi* langeliai eilutėje $r$, kurie yra tarp langelių $(r,a)$ ir $(r,b)$. Tai yra:
 - jei $a \lt b$, tai stadionui turi priklausyti langelis $(r,k)$ kiekvienam $k$, kuriam $a \le k \le b$,
 - jei $a \gt b$, tai stadionui turi priklausyti langelis $(r,k)$ kiekvienam $k$, kuriam $b \le k \le a$.
* Kamuolys iš langelio $(a,c)$ nuspiriamas į langelį $(b,c)$ ($0 \le c,a,b \lt N, a \ne b$), o stadionui priklauso *visi* langeliai  esantys stulpelyje $c$ tarp langelių $(a,c)$ ir $(b,c)$. Tai yra,
 - jei $a \lt b$, tai stadionui turi priklausyti langelis $(k,c)$ kiekvienam $k$, kuriam $a \le k \le b$,
 - jei $a \gt b$, tai stadionui turi priklausyti langelis $(k,c)$ kiekvienam $k$, kuriam $b \le k \le a$.

Stadionas yra **taisyklingas**, jei įmanoma iš bet kurio stadionui priklausančio langelio nuspirti kamuolį į bet kurį kitą stadionui priklausantį langelį ne daugiau nei $2$-iem tiesiais spyriais.
Atkreipkite dėmesį, kad bet koks stadionas, kurio dydis yra $1$, yra taisyklingas.

Pavyzdžiui, panagrinėkime mišką, kurio dydis $N = 5$. Langeliuose $(1,0)$ ir $(4,2)$ yra medžiai, o visi kiti langeliai yra tušti.
Paveiksliukai žemiau nurodo tris įmanomus stadionus. Langeliai su medžiais yra patamsinti, o stadiono langeliai yra dryžuoti.
 
![Stadiums](soccer-regular.png "650")

Kairėje esantis stadionas yra taisyklingas. Viduryje esantis stadionas nėra taisyklingas, nes reikia bent $3$ tiesių spyrių, kad kamuolys iš langelio $(4,1)$ atsidurtų langelyje $(4,3)$. Dešinėje esantis stadionas irgi nėra taisyklingas, nes neįmanoma nuspirti kamuolio iš langelio $(3,0)$ į langelį $(1,3)$ atliekant tik tiesius spyrius.

Sporto klubas nori pastatyti kuo didesnį taisyklingą stadioną.
Raskite didžiausią galimą $s$, kad miške būtų galima pastatyti $s$ dydžio stadioną.

## Realizacija

Parašykite šią funkciją:

```
int biggest_stadium(int N, int[][] F)
```

* $N$: miško dydis.
* $F$: $N$ dydžio masyvas, kurį sudaro $N$ dydžio masyvai, nusakantys miško langelius. Kiekvienam $r$ ir $c$, kuriems galioja $0 \le r \lt N$ ir $0 \le c \lt N$, $F[r][c] = 0$ reiškia, kad $(r, c)$ yra tuščias, o $F[r][c] = 1$ reiškia, kad langelyje yra medis.
* Ši funkcija turėtų grąžinti dydžiausią taisyklingo stadiono, kurį galima pastatyti miške, dydį.
* Ši funkcija iškviečiama lygiai vieną kartą kiekvienam testui.

## Pavyzdys

Panagrinėkime šį iškvietimą:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

Žemiau matote šio pavyzdžio mišką pavaizduotą kairiame paveiksliuke, bei $20$ langelių dydžio taisyklingą stadioną dešiniame paveiksliuke:

![Example](soccer-example.png "400")

Kadangi nėra taisyklingo stadiono, kurio dydis $21$ arba didesnis, funkcija turėtų grąžinti $20$.

## Ribojimai

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ (visiems $i$ ir $j$, kur $0 \le i \lt N$ ir $0 \le j \lt N$)
* Miške yra bent vienas tuščias langelis. Kitaip tariant, $F[i][j] = 0$ bent vienai porai $0 \le i \lt N$ ir $0 \le j \lt N$.

## Dalinės užduotys

1. (6 taškai) Daugiausiai viename langelyje yra medis.
2. (8 taškai) $N \le 3$
3. (22 taškai) $N \le 7$ 
4. (18 taškų) $N \le 30$ 
5. (16 taškų) $N \le 500$
6. (30 taškų) Papildomų ribojimų nėra.

Kiekvienoje dalinėje užduotyje galite gauti 25% dalinės užduoties taškų, jeigu jūsų programa teisingai nustato, ar *visų* tuščių langelių aibė sudaro taisyklingą stadioną.

Tai yra, kiekvienam testui, kuriame visų langelių aibė sudaro taisyklingą stadioną, jūsų sprendimas:
* surenka visus taškus, jeigu grąžina teisingą atsakymą (kuris yra visų tuščių langelių aibės dydis).
* gauna 0 taškų kitu atveju.

Kiekvienam testui, kuriame visų tuščių langelių aibė *ne*sudaro taisyklingo stadiono, jūsų sprendimas:
* gauna visus taškus, jeigu grąžina teisingą atsakymą.
* gauna 0 taškų, jeigu grąžina visų tuščių langelių aibės dydį.
* gauna 25% taškų, jei grąžina bet kokį kitą atsakymą.

Taškų, skiriamų už dalinę užduotį, skaičius lygus mažiausiam taškų skaičiui, gautam už šios dalinės užduoties testus.

## Pavyzdinė vertinimo programa

Pavyzdinė vertinimo programa skaito duomenis šiuo formatu:
 
* $1$-a eilutė: $N$
* $(2 + i)$-a eilutė ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
Pavyzdinė vertinimo programa išveda jūsų atsakymą šiuo formatu:
* $1$-a eilutė: `biggest_stadium` funkcijos grąžinta vertė.
