# ملعب كرة القدم
فورست غابة مربعة الشكل تقع في مدينة سيجد، يمكن اعتبارها شبكة من $N \times N$ خلية.

أسطر الشبكة مرقمة من $0$ إلى $N-1$ من الشمال إلى الجنوب، والأعمدة مرقمة من $0$ إلى $N-1$ من الغرب إلى الشرق. نشير إلى الخلية التي تقع في السطر $r$ والعمود $c$ بالخلية $(r,c)$.

يوجد نوعين من الخلايا في الغابة، إما **فارغة** أو تحوي **شجرة**. حيث يوجد خلية **فارغة** واحدة على الأقل في الغابة. 

*DVSC* نادي رياضي مشهور في المدينة، يخطط هذا النادي لبناء ملعب كرة قدم جديد في الغابة.
حجم الملعب $s$ (حيث $s \ge 1$) هو مجموعة مكونة من $s$ *خلية فارغة مختلفة* $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$. حيث أنه:
* من أجل كل $i$  من $0$ إلى $s-1$ ، ضمناً، الخلية $(r_i, c_i)$ تكون فارغة.
* من أجل كل $j$  تحقق $i \lt j \lt s$، يكون $r_i \neq r_j$ أو $c_i \neq c_j$.

يتم لعب كرة القدم باستخدام كرة تتحرك ضمن خلايا الملعب. نعرف **الضربة المباشرة** بأنها إحدى الحدثين التاليين: 
* تحريك الكرة من الخلية $(r,a)$ إلى الخلية $(r,b)$ ($0 \le r,a,b \lt N, a \ne b$)، حيث يحوي الملعب *كل الخلايا* بين $(r, a)$ و $(r, b)$ في السطر $r$. بمعنى آخر، 
 - إذا كان $a \lt b$ عندها يجب أن يحتوي الملعب كل الخلايا $(r, k)$ (من أجل كل $k$ تحقق $a \le k \le b$).
 - إذا كان $b \lt a$ عندها يجب أن يحتوي الملعب كل الخلايا $(r, k)$ (من أجل كل $k$ تحقق $b \le k \le a$).
* تحريك الكرة من الخلية $(a,c)$ إلى الخلية $(b,c)$ ($0 \le c,a,b \lt N, a \ne b$)، حيث يحتوي الملعب *كل الخلايا* بين الخليتين $(a,c)$ و$(b,c)$ في العمود $c$. بمعنى آخر،
 - إذا كان $a \lt b$ عندها يجب أن يحتوي الملعب كل الخلايا $(k,c)$ (من أجل كل $k$ تحقق $a \le k \le b$)
 - إذا كان $b \lt a$ عندها يجب أن يحتوي الملعب كل الخلايا $(k,c)$ (من أجل كل $k$ تحقق $b \le k \le a$)

نقول عن الملعب أنه **منتظم** إذا كان من الممكن تحريك الكرة من أي خلية تقع ضمن الملعب إلى أي خلية أخرى تقع أيضاً ضمن الملعب وذلك باستخدام ضربتين مباشرتين **اثنتين** على الأكثر. مع الانتباه أن الملعب ذو الحجم 1 هو ملعب منتظم.

على سبيل المثال، لنأخذ الغابة ذات الحجم $N=5$، حيث الخلايا $(1, 0)$ و $(4, 2)$ تحوي أشجاراً، والبقية فارغة. 
الشكل في الأسفل يوضح ثلاثة حالات لبناء ملعب. الخلايا السوداء هي التي تحوي أشجاراً، والخلايا المخلططة  تم أخذها لبناء الملعب.




 
![Stadiums](soccer-regular.png "650")
الملعب على اليسار منتظم. بينما الملعب في المنتصف غير منتظم لأننا نحتاج 3 ضربات مباشرة على الأقل لتحريك الكرة من الخلية $(4, 1)$ إلى الخلية $(4, 3)$. أيضاً المعلب الثالث غير منتظم لأنه من غير الممكن تحريك الكرة من الخلية $(3,0)$ إلى الخلية $(1,3)$ باستخدام الضربات المباشرة.

النادي الرياضي يريد بناء ملعب منتظم بأكبر حجم ممكن. مهمتك هي إيجاد أكبر قيمة لـ $s$ بحيث يوجد ملعب منتظم ذو حجم $s$ ضمن الغابة.


## تفاصيل البرمجة

يجب عليك بناء التابع التالي

```
int biggest_stadium(int N, int[][] F)
```
* $N$: حجم الغابة
* $F$: مصفوفة طولها  $N$ تحوي مصفوفات طولها  $N$، تصف الخلايا ضمن الغابة. من أجل كل $r$ و $c$ حيث $0 \le r \lt N$ و $0 \le c \lt N$, $F[r][c] = 0$ تعني أن خلية $(r, c)$ فارغة، و $F[r][c] = 1$ تعني أن الخلية تحوي شجرة.
* هذا الاتابع عليأن يعيد أكبر حجم ممكن للملعب ينمكن بناؤه ضمن الغابة.
* يتم استدعاء هذا التابع مرة واحدة في كل حالة اختبار.



## مثال

لنأخذ الاستدعاء التالي للتابع:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```
في هذا المثال، الغابة موضحة في الشكل على اليسار، والملعب المنتظم ذو الحجم $20$ موضح في الشكل على اليمين:


![Example](soccer-example.png "400")

باعتبار أنه لا يوجد ملعب منتظم حجمه $21$ أو أكثر، التابع سيعيد القيمة $20$.

## الحدود

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ (من أجل كل $i$ و $j$ حيث $0 \le i \lt N$ و $0 \le j \lt N$)
* يوجد خلية واحدة فارغة على الأقل في الغابة. بمعنى آخر، $F[i][j] = 0$ من أجل ثنائية $0 \le i \lt N$ و $0 \le j  \lt N$ ما.

## المسائل الجزئية 

1. (6 نقاط) يوجد خلية واحدة على *الأكثر* تحوي شجرة.
2. (8 نقاط) $N \le 3$
3. (22 نقاط) $N \le 7$ 
4. (18 نقاط) $N \le 30$ 
5. (16 نقاط) $N \le 500$
6. (30 نقاط) بدون حدود إضافية.

من أجل كل مسألة جزئية، يمكنك ان تحصل على 25% من نتيجة المسألة الجزئية إذا كانت نتيجة البرنامج صحيحة في حال كانت المجموعة التي تضم *كل* الخلايا الخالية تشكل ملعباً منتظماً. 

بشكل أدق، من أجل كل حالة اختبار تحقق ان مجموعة الخلايا الخالية هي ملعب منتظم سينال حلك *
علامة كاملة إذا أوجد الجواب الصحيح (والذي هو عدد عناصر المجموعة المؤلفة من كل الخلايا الخالية) *
وسينال علامة 0 إذا لم يوجد هذا الجواب.

من أجل حالات الاختبار التي تكون المجموعة الحاوية لكل الخلايا الخالية *لسيت* ملعباً منتظماً سينال حلك:
* علامة كاملة إذا أعطى الحل الصحيح.
* علامة الصفر إذا أعطى عدد عناصر المجموعة المكونة من الخلايا الخالية.
* 25% من العلامة إذا أعطى أي قيمة أخرى

ستكون علامة كل مسألة جزئية هي علامة أقل حالة اختبار في هذه المسألة الجزئية.


## المقيم التجريبي

المقيم التجريبي يقرأ الدخل وفق التنسيق التالية: 
 
* line $1$: $N$
* line $2 + i$  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
ويطبع الخرج وفق التنسيق التالي
* line $1$: the return value of `biggest_stadium`



