# สนามฟุตบอล

นายีแอร์เดอ (Nagyerdő) เป็นป่ารูปสี่เหลี่ยมจัตุรัสในเมืองแดแบร็ตแซ็น (Debrecen) ซึ่งจำลองได้เป็นตารางขนาด $N \times N$ เซลล์
แถวมีหมายเลขตั้งแต่ $0$ ถึง $N-1$ จากทิศเหนือไปทิศใต้ และคอลัมน์ก็มีหมายเลขตั้งแต่ $0$ ถึง $N - 1$ จากทิศตะวันตกไปทิศตะวันออก เราจะเรียกเซลล์ที่อยู่ ณ แถว $r$ และคอลัมน์ $c$ ว่าเซลล์ $(r,c)$

ในป่านี้ แต่ละเซลล์อาจจะ**ว่างเปล่า** หรือมี**ต้นไม้** และจะมีอย่างน้อยหนึ่งเซลล์ในป่าที่ว่างเปล่า

DVSC ซึ่งเป็นสโมสรฟุตบอลชื่อดังของเมือง วางแผนจะสร้างสนามฟุตบอลแห่งใหม่ในป่านี้
สนามมีขนาด $s$ (เมื่อ $s \ge 1$) เป็นเซตของเซลล์ที่*ว่างเปล่าและแตกต่างกัน* จำนวน $s$ เซลล์ ประกอบด้วย $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$
กล่าวคือ
* สำหรับแต่ละ $i$ ในช่วง $0$ ถึง $s-1$ รวมหัวท้ายนั้น เซลล์ $(r_i, c_i)$ ต้องว่างเปล่า
* สำหรับแต่ละ $i, j$ ซึ่ง $0 \le i \lt j \lt s$ นั้น $r_i \neq r_j$ เป็นจริง หรือ $c_i \neq c_j$ เป็นจริง (หรือทั้งคู่)

ฟุตบอลเป็นกีฬาที่เล่นด้วยลูกบอลที่ถูกย้ายไปยังเซลล์ต่าง ๆ ในสนาม
นิยามให้ **ลูกเตะตรง** เป็นการกระทำอย่างใดอย่างหนึ่งในสองอย่างนี้

* ย้ายลูกบอลจากเซลล์ $(r,a)$ ไปยังเซลล์ $(r,b)$ ($0 \le r,a,b \lt N, a \ne b$) โดยที่สนามจะต้องประกอบด้วย*ทุก*เซลล์ตั้งแต่ $(r,a)$ จนถึง $(r,b)$ ในแถว $r$ หรือกล่าวอย่างทางการคือ
 - ถ้า $a \lt b$ แล้ว สนามประกอบด้วยเซลล์ $(r,k)$ ทุกค่า $k$ ที่ $a \le k \le b$
 - ถ้า $a \gt b$ แล้ว สนามประกอบด้วยเซลล์ $(r,k)$ ทุกค่า $k$ ที่ $b \le k \le a$
* ย้ายลูกบอลจากเซลล์ $(a,c)$ ไปยังเซลล์ $(b,c)$ ($0 \le c,a,b \lt N, a \ne b$) โดยที่สนามจะต้องประกอบด้วย*ทุก*เซลล์ตั้งแต่ $(a,c)$ จนถึง $(b,c)$ ในคอลัมน์ $c$ หรือกล่าวอย่างทางการคือ
 - ถ้า $a \lt b$ แล้ว สนามประกอบด้วยเซลล์ $(k,c)$ ทุกค่า $k$ ที่ $a \le k \le b$
 - ถ้า $a \gt b$ แล้ว สนามประกอบด้วยเซลล์ $(k,c)$ ทุกค่า $k$ ที่ $b \le k \le a$

สนามจะนับว่าเป็นสนาม**ปกติ** ถ้าเราสามารถย้ายลูกบอลไม่ว่าจะจากเซลล์ใดไปยังเซลล์อื่นใดภายในสนามแห่งนี้ได้เสมอโดยใช้แต่ลูกเตะตรงไม่เกิน $2$ ครั้ง
สังเกตว่าสนามขนาด $1$ ใด ๆ เป็นสนามปกติเสมอ

ตัวอย่างเช่น พิจารณาป่าขนาด  $N = 5$ ที่เซลล์ $(1,0)$ และ $(4,2)$ มีต้นไม้ และเซลล์ที่เหลือทั้งหมดว่างเปล่า รูปประกอบด้านล่างแสดงตัวอย่างสนามสามสนาม โดยเซลล์ที่มีต้นไม้เป็นสีทึบ และสนามประกอบด้วยเซลล์ที่เป็นลายทาง

![Stadiums](soccer-regular.png "650")

สนามในรูปซ้ายเป็นสนามปกติ ส่วนสนามในรูปกลางไม่ใช่สนามปกติ เพราะต้องใช้ลูกเตะตรงอย่างน้อย $3$ ครั้งในการย้ายลูกบอลจากเซลล์ $(4,1)$ ไป $(4,3)$ สนามในรูปขวาก็ไม่ใช่สนามปกติ เพราะไม่สามารถย้ายลูกบอลจากเซลล์ $(3,0)$ ไป $(1,3)$ โดยใช้แต่ลูกเตะตรง

สโมสรดังกล่าวต้องการสร้างสนามปกติที่มีขนาดใหญ่ที่สุดเท่าที่เป็นไปได้

งานของคุณคือ หาค่าของ $s$ ที่มากที่สุด ที่มีสนามปกติขนาด $s$ ในป่าแห่งนี้

## รายละเอียดการเขียนโปรแกรม

คุณจะต้องเขียนฟังก์ชันต่อไปนี้

```
int biggest_stadium(int N, int[][] F)
```

* $N$: ขนาดของป่า
* $F$: อาร์เรย์ขนาด $N$ ที่สมาชิกแต่ละตัวเป็นอาร์เรย์ขนาด $N$ ซึ่งอธิบายเซลล์ในป่า
โดยสำหรับแต่ละ $r$ และ $c$ ซึ่ง $0 \le r \lt N$ และ $0 \le c \lt N$ นั้น $F[r][c] = 0$ หมายความว่าเซลล์ $(r, c)$ ว่างเปล่า และ $F[r][c] = 1$ หมายความว่าเซลล์นั้นมีต้นไม้
* ฟังก์ชันนี้ต้องคืนค่าเป็นขนาดที่ใหญ่ที่สุดเท่าที่เป็นไปได้ของสนามปกติที่สร้างได้ในป่านี้
* ฟังก์ชันนี้จะถูกเรียกเพียงหนึ่งครั้งสำหรับแต่ละข้อมูลทดสอบ

## ตัวอย่าง

พิจารณาการเรียกฟังก์ชันต่อไปนี้:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```
ในตัวอย่างนี้ รูปด้านซ้ายแสดงป่า และรูปด้านขวาแสดงสนามปกติขนาด $20$ สนามหนึ่ง

![Example](soccer-example.png "400")

เนื่องจากไม่มีสนามปกติขนาด $21$ หรือใหญ่กว่าที่เป็นไปได้ ฟังก์ชันต้องคืนค่า $20$

## ข้อจำกัด

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ (สำหรับแต่ละ $i$ และ $j$ ที่ $0 \le i \lt N$ และ $0 \le j \lt N$)
* มีอย่างน้อยหนึ่งเซลล์ในป่าที่ว่างเปล่า หรือกล่าวคือ $F[i][j] = 0$ สำหรับบางค่า $0 \le i \lt N$ และ $0 \le j \lt N$

## ปัญหาย่อย

1. (6 คะแนน) มีอย่างมากหนึ่งเซลล์ที่มีต้นไม้
2. (8 คะแนน) $N \le 3$
3. (22 คะแนน) $N \le 7$ 
4. (18 คะแนน) $N \le 30$ 
5. (16 คะแนน) $N \le 500$
6. (30 คะแนน) ไม่มีข้อจำกัดใดเพิ่มเติม

ในแต่ละปัญหาย่อย คุณสามารถได้คะแนน 25% ของปัญหาย่อยนั้น
ถ้าโปรแกรมของคุณตอบได้ถูกต้องว่าเซตที่ประกอบด้วย*ทุก*เซลล์ที่ว่างเปล่า จัดว่าเป็นสนามปกติหรือไม่

กล่าวให้ชัดเจนขึ้น สำหรับแต่ละข้อมูลทดสอบที่เซตที่ประกอบด้วยทุกเซลล์ที่ว่างเปล่าจัดว่าเป็นสนามปกติ โปรแกรมของคุณ
* ได้คะแนนเต็ม ถ้าคืนค่าได้ถูกต้อง (ซึ่งเท่ากับขนาดของเซตที่ประกอบด้วยทุกเซลล์ที่ว่างเปล่า)
* มิฉะนั้นได้ $0$ คะแนน

สำหรับแต่ละข้อมูลทดสอบที่เซตที่ประกอบด้วยทุกเซลล์ที่ว่างเปล่า*ไม่*จัดว่าเป็นสนามปกติ โปรแกรมของคุณ
* ได้คะแนนเต็ม ถ้าคืนค่าได้ถูกต้อง
* ได้ $0$ คะแนน ถ้าคืนค่าเป็นขนาดของเซตที่ประกอบด้วยทุกเซลล์ที่ว่างเปล่า
* ได้คะแนน 25% ถ้าคืนค่าอื่น ๆ ค่าใดก็ได้

คะแนนของแต่ละปัญหาย่อยคือคะแนนที่น้อยที่สุดของข้อมูลทดสอบทั้งหมดในปัญหาย่อยนั้น

## เกรดเดอร์ตัวอย่าง

เกรดเดอร์ตัวอย่างจะอ่านค่าอินพุตในรูปแบบดังนี้:
 
* บรรทัดที่ $1$: $N$
* บรรทัดที่ $2 + i$  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
เกรดเดอร์ตัวอย่างจะแสดงคําตอบของคุณในรูปแบบต่อไปนี้:
* บรรทัดที่ $1$: ค่าที่คืนจากการเรียกฟังก์ชัน `biggest_stadium`
