# Futbol Stadyumu 
Nagyerdő, Debrecen şehrinde bulunan ve $N \times N$ hücre ızgarası olarak modellenebilecek kare şeklinde bir ormandır.
Izgaranın satırları kuzeyden güneye $0$ ile $N - 1$ arasında numaralandırılmıştır ve
sütunlar batıdan doğuya $0$ ile $N - 1$ arasında numaralandırılmıştır.
Izgaranın $r$ numaralı satırında ve $c$ numaralı sütununda bulunan hücreye $(r, c)$ hücresi diyoruz.

Ormandaki her hücre ya **boştur** ya da bir **ağaç** içerir.
Ormandaki en az bir hücre boştur.

Kentin ünlü spor kulübü DVSC, ormanın içine yeni bir futbol stadyumu inşa etmeyi planlıyor.
$s$ boyutunda bir stadyum (burada $s \ge 1$), $s$ adet *birbirinden farklı ve boş* hücreden oluşan bir kümedir. $s$ kümesinin elemanı olan hücreleri $(r_0, c_0), \ldots, (r_{s - 1}, c_{s - 1})$ olarak isimlendiriyoruz. Daha açık olarak ifade edersek:
- $0$ ile $s - 1$ arasındaki (sınırlar dahil) her $i$ için $(r_i, c_i)$ hücresi boştur,
- $0 \le i \lt j \lt s$ şartını sağlayan her $i, j$ için $r_i \neq r_j$ ve $c_i \neq c_j$ eşitsizliklerinin en az biri doğrudur.

Futbol, stadyumun hücrelerinde hareket ettirilen bir top kullanılarak oynanır.
**Düz vuruş** aşağıdaki iki hareketten biri olarak tanımlanır:

* Topu $(r,a)$ hücresinden $(r,b)$ ($0 \le r,a,b \lt N, a \ne b$) hücresine taşıyın. Stadyum $r$ satırındaki $(r,a)$ ve $(r,b)$ hücreleri arasında *tüm* hücreleri içermelidir. Başka bir deyişle,
  - eğer $a \lt b$ ise stadyum $a \le k \le b$ şartını sağlayan her $k$ için $(r,k)$ hücresini içermelidir,
  - eğer $a \gt b$ ise stadyum $b \le k \le a$ şartını sağlayan her $k$ için $(r,k)$ hücresini içermelidir.
* Topu $(a,c)$ hücresinden $(b,c)$ ($0 \le c,a,b \lt N, a \ne b$) hücresine taşıyın. Stadyum $c$ sütunundaki $(a,c)$ ve $(b,c)$ hücreleri arasındaki *tüm* hücreleri içermelidir. Başka bir deyişle, 
  - eğer $a \lt b$ ise stadyum $a \le k \le b$ şartını sağlayan her $k$ için $(k,c)$ hücresini içermelidir,
  - eğer $a \gt b$ ise stadyum $b \le k \le a$ şartını sağlayan her $k$ için $(k,c)$ hücresini içermelidir.

Eğer topu stadyumun içerdiği herhangi bir hücreden stadyumun içerdiği herhangi bir noktaya en fazla $2$ düz vuruş kullanarak taşımak mümkün ise stadyuma **düzenli** stadyum denir. $1$ büyüklüğündeki herhangi bir stadyumun düzenli olduğunu unutmayın.

Örnek olarak $N = 5$ boyutunda bir orman düşünün; $(1,0)$ ve $(4,2)$ hücreleri ağaçlar içersin ve diğer tüm hücreler boş olsun. Aşağıdaki şekil üç olası stadyumu göstermektedir. Ağaçların bulunduğu hücreler karartılmış ve stadyumun içerdiği hücreler çizgilidir.

 
![Stadiums](soccer-regular.png "650")

Soldaki stadyum düzenlidir. Ancak ortadaki stadyum düzenli değildir çünkü topu $(4,1)$ hücresinden $(4,3)$ hücresine taşımak için en az $3$ düz vuruş gerekmektedir. Sağdaki stadyum da düzenli değildir çünkü topu $(3,0)$ hücresinden $(1,3)$ hücresine düz vuruşlarla taşımak mümkün değildir.

Spor kulübü mümkün olan en büyük düzenli stadyumu inşa etmek istiyor.
Göreviniz, ormanda $s$ büyüklüğünde düzenli bir stadyumun mevcut olduğu en büyük $s$ değerini bulmaktır.


## Kodlama Detayları

Aşağıdaki prosedürü kodlamalısınız.

```
int biggest_stadium(int N, int[][] F)
```

* $N$: ormanın boyutu.
* $F$: $N$ uzunluğunda diziler içeren $N$ uzunluğunda bir dizi. Bu dizi ormanın hücrelerini tarif etmektedir. $0 \le r \lt N$ ve $0 \le c \lt N$ şartını sağlayan her $r$ ve $c$ için $F[r][c] = 0$ olması $(r, c)$ hücresinin boş olduğunu, $F[r][c] = 1$ olması ise $(r, c)$ hücresinin ağaç içerdiğini göstermektedir.
* Bu prosedür, ormanda inşa edilebilecek en büyük düzenli stadyumun boyutunu döndürmelidir.
* Bu prosedür her test durumu için tam olarak bir kez çağrılır.

## Örnek

Aşağıdaki çağrıya bakınız:

```
biggest_stadium(5, [[0, 0, 0, 0, 0],  
                    [1, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 0, 0, 0], 
                    [0, 0, 1, 0, 0]])
```

Bu örnekte, aşağıdaki şeklin solunda orman, sağında ise $20$ boyutunda düzenli bir stadyum gösterilmektedir:


![Example](soccer-example.png "400")

Boyutu $21$ veya daha büyük olan düzenli bir stadyum olmadığından prosedür $20$ dönmelidir.


## Kısıtlar

* $1 \le N \le  2\,000$
* $0 \le F[i][j] \le 1$ ($0 \le i \lt N$ ve $0 \le j \lt N$ şartlarını sağlayan her $i$ ve $j$ için)
* Ormanda en az bir tane boş hücre vardır. Başka bir deyişle, $0 \le i \lt N$ ve $0 \le j \lt N$ şartlarını sağlayan en az bir $i$ ve $j$ ikilisi için $F[i][j] = 0$'dır.

## Altgörevler

1. (6 puan) There is at most one cell containing a tree.
2. (8 puan) $N \le 3$
3. (22 puan) $N \le 7$ 
4. (18 puan) $N \le 30$ 
5. (16 puan) $N \le 500$
6. (30 puan) Başkaca kısıt yoktur.
 
Programınız *bütün* boş hücrelerden oluşan stadyumun düzenli bir stadyum olup olmadığına doğru bir şekilde karar verirse, her alt görevde alt görev puanının %25'ini elde edebilirsiniz.

Daha açık bir ifadeyle, tüm boş hücrelerden oluşan stadyumun normal bir stadyum olduğu her test durumu için çözümünüz:
* doğru yanıtı verirse (yani tüm boş hücrelerin sayısını dönerse) tam puan alır.

* aksi halde 0 puan alır.

Tüm boş hücrelerden oluşan stadyumun düzenli bir stadyum *olmadığı* her test durumu için çözümünüz:
* doğru cevabı verirse tam puan alır.
* tüm boş hücrelerden oluşan kümenin boyutunu döndürürse 0 puan alır.
* başka bir değer döndürürse puanın %25'ini alır.

Her alt görevin puanı, alt görevdeki test durumlarının minimum puanıdır.

## Örnek Değerlendirici

Örnek değerlendirici girdiyi aşağıdaki formatta okumaktadır: 
 
* satır $1$: $N$
* satır $2 + i$  ($0 \le i \lt N$):  $F[i][0] \; F[i][1] \; \ldots \; F[i][N - 1]$
 
 Örnek değerlendirici cevabınızı aşağıdaki formatta yazdırır:
* satır $1$: `biggest_stadium` prosedürünün döndüğü değer
 
